/*!
 * Copyright (c) 2012 - 2020, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
*/
(function(root, factory) {
  factory(root["Bokeh"]);
})(this, function(Bokeh) {
  var define;
  return (function(modules, entry, aliases, externals) {
    if (Bokeh != null) {
      return Bokeh.register_plugin(modules, entry, aliases, externals);
    } else {
      throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
    }
  })
({
"22ae8fda70": function _(a,e,r){Object.defineProperty(r,"__esModule",{value:!0});const o=a("tslib");var t=a("3343056bd8");r.AcePlot=t.AcePlot;var d=a("66d52165db");r.Audio=d.Audio;var l=a("71a9759436");r.CommManager=l.CommManager;var b=a("f6b9b1d914");r.DeckGLPlot=b.DeckGLPlot;var v=a("ae707e931d");r.HTML=v.HTML;var c=a("9ba5b8422a");r.JSON=c.JSON;var P=a("a94e371ba4");r.FileDownload=P.FileDownload;var f=a("7b859fb3cf");r.KaTeX=f.KaTeX;var i=a("0c21036737");r.MathJax=i.MathJax;var n=a("000f20fdd3");r.Player=n.Player;var s=a("2363c12dd6");r.PlotlyPlot=s.PlotlyPlot;var M=a("76307e5afa");r.Progress=M.Progress;var S=a("38b2bc9574");r.State=S.State;var g=a("90d1f929bd");r.VegaPlot=g.VegaPlot;var m=a("b0c3e9e9c2");r.Video=m.Video;var V=a("3c7145a2fa");r.VideoStream=V.VideoStream,o.__exportStar(a("ecfbb965eb"),r)},
"3343056bd8": function _(e,t,o){Object.defineProperty(o,"__esModule",{value:!0});const i=e("tslib").__importStar(e("@bokehjs/core/properties")),s=e("@bokehjs/models/layouts/html_box"),n=e("@bokehjs/core/dom"),a=e("ba20932521");class d extends a.PanelHTMLBoxView{initialize(){super.initialize(),this._ace=window.ace,this._container=n.div({id:"_"+Math.random().toString(36).substr(2,9),style:{width:"100%",height:"100%"}})}connect_signals(){super.connect_signals(),this.connect(this.model.properties.code.change,()=>this._update_code_from_model()),this.connect(this.model.properties.theme.change,()=>this._update_theme()),this.connect(this.model.properties.language.change,()=>this._update_language()),this.connect(this.model.properties.annotations.change,()=>this._add_annotations()),this.connect(this.model.properties.readonly.change,()=>{this._editor.setReadOnly(this.model.readonly)})}render(){super.render(),this._container!==this.el.childNodes[0]&&this.el.appendChild(this._container),this._container.textContent=this.model.code,this._editor=this._ace.edit(this._container.id),this._editor.setTheme("ace/theme/"+`${this.model.theme}`),this._editor.session.setMode("ace/mode/"+`${this.model.language}`),this._editor.setReadOnly(this.model.readonly),this._langTools=this._ace.require("ace/ext/language_tools"),this._editor.setOptions({enableBasicAutocompletion:!0,enableSnippets:!0,fontFamily:"monospace"}),this._editor.on("change",()=>this._update_code_from_editor())}_update_code_from_model(){this._editor&&this._editor.getValue()!=this.model.code&&this._editor.setValue(this.model.code)}_update_code_from_editor(){this._editor.getValue()!=this.model.code&&(this.model.code=this._editor.getValue())}_update_theme(){this._editor.setTheme("ace/theme/"+`${this.model.theme}`)}_update_language(){this._editor.session.setMode("ace/mode/"+`${this.model.language}`)}_add_annotations(){this._editor.session.setAnnotations(this.model.annotations)}after_layout(){super.after_layout(),this._editor.resize()}}o.AcePlotView=d,d.__name__="AcePlotView";class h extends s.HTMLBox{constructor(e){super(e)}static init_AcePlot(){this.prototype.default_view=d,this.define({code:[i.String],language:[i.String,"python"],theme:[i.String,"chrome"],annotations:[i.Array,[]],readonly:[i.Boolean,!1]}),this.override({height:300,width:300})}}o.AcePlot=h,h.__name__="AcePlot",h.__module__="panel.models.ace",h.init_AcePlot()},
"ba20932521": function _(e,i,t){Object.defineProperty(t,"__esModule",{value:!0});const s=e("@bokehjs/core/layout/layoutable"),h=e("@bokehjs/core/layout/types"),o=e("@bokehjs/core/dom"),_=e("@bokehjs/models/widgets/markup"),n=e("@bokehjs/models/layouts/html_box");function a(e,i){let t=null!=i.width?"fixed":"fit",s=null!=i.height?"fixed":"fit";const{sizing_mode:h}=i;if(null!=h)if("fixed"==h)t=s="fixed";else if("stretch_both"==h)t=s="max";else if("stretch_width"==h)t="max";else if("stretch_height"==h)s="max";else switch(h){case"scale_width":t="max",s="min";break;case"scale_height":t="min",s="max";break;case"scale_both":t="max",s="max";break;default:throw new Error("unreachable")}"fixed"==t&&i.width?e.style.width=i.width+"px":"max"==t&&(e.style.width="100%"),"fixed"==s&&i.height?e.style.height=i.height+"px":"max"==s&&(e.style.height="100%")}t.set_size=a;class d extends s.Layoutable{constructor(e,i,t){super(),this.el=e,this.sizing_mode=i,this.changed=t,this._cache={},this._cache_count={}}_measure(e){const i=[e.width,e.height,this.sizing_mode].toString(),t=this.changed&&"fixed"!=this.sizing_mode&&null!=this.sizing_mode?1:0;if(i in this._cache&&this._cache_count[i]>=t)return this._cache_count[i]=this._cache_count[i]+1,this._cache[i];const s=new h.Sizeable(e).bounded_to(this.sizing.size),_=o.sized(this.el,s,()=>{const e=new h.Sizeable(o.content_size(this.el)),{border:i,padding:t}=o.extents(this.el);return e.grow_by(i).grow_by(t).map(Math.ceil)});return this._cache[i]=_,this._cache_count[i]=0,_}}t.CachedVariadicBox=d,d.__name__="CachedVariadicBox";class l extends _.MarkupView{_update_layout(){let e=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new d(this.el,this.model.sizing_mode,e),this.layout.set_sizing(this.box_sizing())}render(){super.render(),a(this.markup_el,this.model)}}t.PanelMarkupView=l,l.__name__="PanelMarkupView";class c extends n.HTMLBoxView{_update_layout(){let e=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new d(this.el,this.model.sizing_mode,e),this.layout.set_sizing(this.box_sizing())}render(){super.render(),a(this.el,this.model)}}t.PanelHTMLBoxView=c,c.__name__="PanelHTMLBoxView"},
"66d52165db": function _(e,t,i){Object.defineProperty(i,"__esModule",{value:!0});const o=e("tslib").__importStar(e("@bokehjs/core/properties")),s=e("@bokehjs/models/layouts/html_box"),l=e("ba20932521");class d extends l.PanelHTMLBoxView{initialize(){super.initialize(),this._blocked=!1,this._setting=!1,this._time=Date.now()}connect_signals(){super.connect_signals(),this.connect(this.model.properties.loop.change,()=>this.set_loop()),this.connect(this.model.properties.paused.change,()=>this.set_paused()),this.connect(this.model.properties.time.change,()=>this.set_time()),this.connect(this.model.properties.value.change,()=>this.set_value()),this.connect(this.model.properties.volume.change,()=>this.set_volume())}render(){super.render(),this.audioEl=document.createElement("audio"),this.audioEl.controls=!0,this.audioEl.src=this.model.value,this.audioEl.currentTime=this.model.time,this.audioEl.loop=this.model.loop,null!=this.model.volume?this.audioEl.volume=this.model.volume/100:this.model.volume=100*this.audioEl.volume,this.audioEl.onpause=()=>this.model.paused=!0,this.audioEl.onplay=()=>this.model.paused=!1,this.audioEl.ontimeupdate=()=>this.update_time(this),this.audioEl.onvolumechange=()=>this.update_volume(this),this.el.appendChild(this.audioEl),this.model.paused||this.audioEl.play()}update_time(e){e._setting?e._setting=!1:Date.now()-e._time<e.model.throttle||(e._blocked=!0,e.model.time=e.audioEl.currentTime,e._time=Date.now())}update_volume(e){e._setting?e._setting=!1:(e._blocked=!0,e.model.volume=100*e.audioEl.volume)}set_loop(){this.audioEl.loop=this.model.loop}set_paused(){!this.audioEl.paused&&this.model.paused&&this.audioEl.pause(),this.audioEl.paused&&!this.model.paused&&this.audioEl.play()}set_volume(){this._blocked?this._blocked=!1:(this._setting=!0,null!=this.model.volume&&(this.audioEl.volume=this.model.volume/100))}set_time(){this._blocked?this._blocked=!1:(this._setting=!0,this.audioEl.currentTime=this.model.time)}set_value(){this.audioEl.src=this.model.value}}i.AudioView=d,d.__name__="AudioView";class u extends s.HTMLBox{constructor(e){super(e)}static init_Audio(){this.prototype.default_view=d,this.define({loop:[o.Boolean,!1],paused:[o.Boolean,!0],time:[o.Number,0],throttle:[o.Number,250],value:[o.Any,""],volume:[o.Number,null]})}}i.Audio=u,u.__name__="Audio",u.__module__="panel.models.widgets",u.init_Audio()},
"71a9759436": function _(e,t,n){Object.defineProperty(n,"__esModule",{value:!0});const o=e("tslib").__importStar(e("@bokehjs/core/properties")),i=e("@bokehjs/document"),s=e("@bokehjs/core/view"),c=e("@bokehjs/model"),_=e("@bokehjs/protocol/message"),l=e("@bokehjs/protocol/receiver");class r extends s.View{renderTo(){}}n.CommManagerView=r,r.__name__="CommManagerView";class a extends c.Model{constructor(e){super(e),this._document_listener=e=>this._document_changed(e),this._receiver=new l.Receiver,this._event_buffer=[],this._blocked=!1,this._timeout=Date.now(),null!=window.PyViz&&window.PyViz.comm_manager?(this.ns=window.PyViz,this.ns.comm_manager.register_target(this.plot_id,this.comm_id,e=>this.msg_handler(e)),this._client_comm=this.ns.comm_manager.get_client_comm(this.plot_id,this.client_comm_id,e=>this.on_ack(e))):console.log("Could not find comm manager on window.PyViz, ensure the extension is loaded.")}_doc_attached(){super._doc_attached(),null!=this.document&&this.document.on_change(this._document_listener)}_document_changed(e){e.setter_id!==this.id&&(e instanceof i.ModelChangedEvent&&!(e.attr in e.model.serializable_attributes())||(this._event_buffer.unshift(e),(!this._blocked||Date.now()>this._timeout)&&(setTimeout(()=>this.process_events(),this.debounce),this._blocked=!0,this._timeout=Date.now()+this.timeout)))}process_events(){if(null==this.document||null==this._client_comm)return;const e=_.Message.create("PATCH-DOC",{},this.document.create_json_patch(this._event_buffer));this._client_comm.send(e),this._event_buffer=[]}on_ack(e){const t=e.metadata;this._event_buffer.length?(this.process_events(),this._blocked=!0,this._timeout=Date.now()+this.timeout):this._blocked=!1,this._event_buffer=[],"Ready"==t.msg_type&&t.content?console.log("Python callback returned following output:",t.content):"Error"==t.msg_type&&console.log("Python failed with the following traceback:",t.traceback)}msg_handler(e){const t=e.metadata,n=e.buffers,o=e.content.data,i=this.plot_id;if("Ready"==t.msg_type)t.content?console.log("Python callback returned following output:",t.content):"Error"==t.msg_type&&console.log("Python failed with the following traceback:",t.traceback);else if(null!=i){let e=null;if(i in this.ns.plot_index&&null!=this.ns.plot_index[i]?e=this.ns.plot_index[i]:void 0!==window.Bokeh&&i in window.Bokeh.index&&(e=window.Bokeh.index[i]),null==e)return;null!=n&&n.length>0?this._receiver.consume(n[0].buffer):this._receiver.consume(o);const t=this._receiver.message;null!=t&&Object.keys(t.content).length>0&&null!=this.document&&this.document.apply_json_patch(t.content,t.buffers,this.id)}}static init_CommManager(){this.prototype.default_view=r,this.define({plot_id:[o.String,null],comm_id:[o.String,null],client_comm_id:[o.String,null],timeout:[o.Number,5e3],debounce:[o.Number,50]})}}n.CommManager=a,a.__name__="CommManager",a.__module__="panel.models.comm_manager",a.init_CommManager()},
"f6b9b1d914": function _(e,t,o){Object.defineProperty(o,"__esModule",{value:!0});const i=e("tslib"),a=e("@bokehjs/core/dom"),s=i.__importStar(e("@bokehjs/core/properties")),n=e("@bokehjs/models/layouts/html_box"),c=e("ba20932521"),r=e("064eac2866"),d=i.__importDefault(e("093eb75864")),l=window.deck,_=window.mapboxgl,h=window.loaders;function p(){const e={},t=Object.keys(l).filter(e=>e.charAt(0)===e.charAt(0).toUpperCase());for(const o of t)e[o]=l[o];return e}class u extends c.PanelHTMLBoxView{connect_signals(){super.connect_signals();const{data:e,mapbox_api_key:t,tooltip:o,layers:i,initialViewState:a,data_sources:s}=this.model.properties;this.on_change([t,o],()=>this.render()),this.on_change([e,a],()=>this.updateDeck()),this.on_change([i],()=>this._update_layers()),this.on_change([s],()=>this._connect_sources(!0)),this._layer_map={},this._connected=[],this._connect_sources()}_update_layers(){this._layer_map={},this._update_data(!0)}_connect_sources(e=!1){for(const e of this.model.data_sources)this._connected.indexOf(e)<0&&(this.connect(e.properties.data.change,()=>this._update_data(!0)),this._connected.push(e));this._update_data(e)}initialize(){if(super.initialize(),l.JSONConverter){const{CSVLoader:e,Tile3DLoader:t}=h;h.registerLoaders([t,e]);const o={classes:p(),enumerations:{COORDINATE_SYSTEM:l.COORDINATE_SYSTEM,GL:d.default},constants:{Tile3DLoader:t}};this.jsonConverter=new l.JSONConverter({configuration:o})}}_update_data(e=!0){let t=0;for(const e of this.model.layers){let o;if(t+=1,t-1 in this._layer_map)o=this.model.data_sources[this._layer_map[t-1]];else{if("number"!=typeof e.data)continue;this._layer_map[t-1]=e.data,o=this.model.data_sources[e.data]}const i=[],a=o.columns();for(let e=0;e<o.data[a[0]].length;e++){const t={};for(const i of a){const a=o._shapes[i];void 0!==a&&a.length>1&&"number"==typeof a[0]?t[i]=o.data[i].slice(e*a[1],e*a[1]+a[1]):t[i]=o.data[i][e]}i.push(t)}e.data=i}e&&this.updateDeck()}_on_click_event(e){const t={coordinate:e.coordinate,lngLat:e.lngLat,index:e.index};this.model.clickState=t}_on_hover_event(e){const t={coordinate:e.coordinate,lngLat:e.lngLat,index:e.index};this.model.hoverState=t}_on_viewState_event(e){this.model.viewState=e.viewState}getData(){return Object.assign(Object.assign({},this.model.data),{layers:this.model.layers,initialViewState:this.model.initialViewState,onViewStateChange:e=>this._on_viewState_event(e),onClick:e=>this._on_click_event(e),onHover:e=>this._on_hover_event(e)})}updateDeck(){if(!this.deckGL)return void this.render();const e=this.getData();if(l.updateDeck)l.updateDeck(e,this.deckGL);else{const t=this.jsonConverter.convert(e);this.deckGL.setProps(t)}}createDeck({mapboxApiKey:e,container:t,jsonInput:o,tooltip:i}){let a;try{const s=this.jsonConverter.convert(o),n=r.makeTooltip(i);a=new l.DeckGL(Object.assign(Object.assign({},s),{map:_,mapboxApiAccessToken:e,container:t,getTooltip:n}))}catch(e){console.error(e)}return a}render(){super.render();const e=a.div({class:"deckgl"});c.set_size(e,this.model);const t=this.model.mapbox_api_key,o=this.model.tooltip,i=this.getData();l.createDeck?this.deckGL=l.createDeck({mapboxApiKey:t,container:e,jsonInput:i,tooltip:o}):this.deckGL=this.createDeck({mapboxApiKey:t,container:e,jsonInput:i,tooltip:o}),this.el.appendChild(e)}}o.DeckGLPlotView=u,u.__name__="DeckGLPlotView";class m extends n.HTMLBox{constructor(e){super(e)}static init_DeckGLPlot(){this.prototype.default_view=u,this.define({data:[s.Any],data_sources:[s.Array,[]],clickState:[s.Any],hoverState:[s.Any],initialViewState:[s.Any],layers:[s.Array,[]],mapbox_api_key:[s.String],tooltip:[s.Any],viewState:[s.Any]}),this.override({height:400,width:600})}}o.DeckGLPlot=m,m.__name__="DeckGLPlot",m.__module__="panel.models.deckgl",m.init_DeckGLPlot()},
"064eac2866": function _(e,t,n){
/*
    This file was adapted from https://github.com/uber/deck.gl/ the LICENSE
    below is preserved to comply with the original license.
    
    Copyright (c) 2015 - 2017 Uber Technologies, Inc.
    
    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:
    
    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.
    
    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
    THE SOFTWARE.
    */
let i,l;Object.defineProperty(n,"__esModule",{value:!0});const o={fontFamily:'"Helvetica Neue", Helvetica, Arial, sans-serif',display:"flex",flex:"wrap",maxWidth:"500px",flexDirection:"column",zIndex:2};function r(){return document.createElement("div")}function s(e){if(!e.picked)return null;if(e.object===i)return l;const t={html:a(e.object),style:o};return l=t,i=e.object,t}n.getTooltipDefault=s;const c=new Set(["position","index"]);function a(e){const t=r();for(const n in e){if(c.has(n))continue;const i=r();i.className="header",i.textContent=n;const l=r();l.className="value",l.textContent=u(e[n]);const o=r();f(o,i,l),o.appendChild(i),o.appendChild(l),t.appendChild(o)}return t.innerHTML}function f(e,t,n){Object.assign(t.style,{fontWeight:700,marginRight:"10px",flex:"1 1 0%"}),Object.assign(n.style,{flex:"none",maxWidth:"250px",overflow:"hidden",whiteSpace:"nowrap",textOverflow:"ellipsis"}),Object.assign(e.style,{display:"flex",flexDirection:"row",justifyContent:"space-between",alignItems:"stretch"})}function u(e){let t;if(Array.isArray(e)&&e.length>4)t=`Array<${e.length}>`;else if("string"==typeof e)t=e;else if("number"==typeof e)t=String(e);else try{t=JSON.stringify(e)}catch(e){t="<Non-Serializable Object>"}return t.length>50&&(t=t.slice(0,50)),t}function p(e,t){let n=e;for(const e in t)n=n.replace(`{${e}}`,t[e]);return n}n.tabularize=a,n.toText=u,n.substituteIn=p,n.makeTooltip=function(e){return e?e.html||e.text?t=>{if(!t.picked)return null;const n={style:e.style||o};return e.html?n.html=p(e.html,t.object):n.text=p(e.text,t.object),n}:s:null}},
"093eb75864": function _(E,_,R){_.exports={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,FUNC_ADD:32774,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,BLEND_COLOR:32773,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,VENDOR:7936,RENDERER:7937,VERSION:7938,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,BROWSER_DEFAULT_WEBGL:37444,STATIC_DRAW:35044,STREAM_DRAW:35040,DYNAMIC_DRAW:35048,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,CULL_FACE:2884,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,BLEND:3042,DEPTH_TEST:2929,DITHER:3024,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,SCISSOR_TEST:3089,STENCIL_TEST:2960,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CONTEXT_LOST_WEBGL:37442,CW:2304,CCW:2305,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DOUBLE:5130,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,COMPILE_STATUS:35713,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_ATTRIBUTES:35721,ACTIVE_UNIFORMS:35718,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,ALWAYS:519,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,GEQUAL:518,NOTEQUAL:517,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,TEXTURE_WIDTH:4096,TEXTURE_HEIGHT:4097,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,READ_FRAMEBUFFER:36008,DRAW_FRAMEBUFFER:36009,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,READ_BUFFER:3074,UNPACK_ROW_LENGTH:3314,UNPACK_SKIP_ROWS:3315,UNPACK_SKIP_PIXELS:3316,PACK_ROW_LENGTH:3330,PACK_SKIP_ROWS:3331,PACK_SKIP_PIXELS:3332,TEXTURE_BINDING_3D:32874,UNPACK_SKIP_IMAGES:32877,UNPACK_IMAGE_HEIGHT:32878,MAX_3D_TEXTURE_SIZE:32883,MAX_ELEMENTS_VERTICES:33e3,MAX_ELEMENTS_INDICES:33001,MAX_TEXTURE_LOD_BIAS:34045,MAX_FRAGMENT_UNIFORM_COMPONENTS:35657,MAX_VERTEX_UNIFORM_COMPONENTS:35658,MAX_ARRAY_TEXTURE_LAYERS:35071,MIN_PROGRAM_TEXEL_OFFSET:35076,MAX_PROGRAM_TEXEL_OFFSET:35077,MAX_VARYING_COMPONENTS:35659,FRAGMENT_SHADER_DERIVATIVE_HINT:35723,RASTERIZER_DISCARD:35977,VERTEX_ARRAY_BINDING:34229,MAX_VERTEX_OUTPUT_COMPONENTS:37154,MAX_FRAGMENT_INPUT_COMPONENTS:37157,MAX_SERVER_WAIT_TIMEOUT:37137,MAX_ELEMENT_INDEX:36203,RED:6403,RGB8:32849,RGBA8:32856,RGB10_A2:32857,TEXTURE_3D:32879,TEXTURE_WRAP_R:32882,TEXTURE_MIN_LOD:33082,TEXTURE_MAX_LOD:33083,TEXTURE_BASE_LEVEL:33084,TEXTURE_MAX_LEVEL:33085,TEXTURE_COMPARE_MODE:34892,TEXTURE_COMPARE_FUNC:34893,SRGB:35904,SRGB8:35905,SRGB8_ALPHA8:35907,COMPARE_REF_TO_TEXTURE:34894,RGBA32F:34836,RGB32F:34837,RGBA16F:34842,RGB16F:34843,TEXTURE_2D_ARRAY:35866,TEXTURE_BINDING_2D_ARRAY:35869,R11F_G11F_B10F:35898,RGB9_E5:35901,RGBA32UI:36208,RGB32UI:36209,RGBA16UI:36214,RGB16UI:36215,RGBA8UI:36220,RGB8UI:36221,RGBA32I:36226,RGB32I:36227,RGBA16I:36232,RGB16I:36233,RGBA8I:36238,RGB8I:36239,RED_INTEGER:36244,RGB_INTEGER:36248,RGBA_INTEGER:36249,R8:33321,RG8:33323,R16F:33325,R32F:33326,RG16F:33327,RG32F:33328,R8I:33329,R8UI:33330,R16I:33331,R16UI:33332,R32I:33333,R32UI:33334,RG8I:33335,RG8UI:33336,RG16I:33337,RG16UI:33338,RG32I:33339,RG32UI:33340,R8_SNORM:36756,RG8_SNORM:36757,RGB8_SNORM:36758,RGBA8_SNORM:36759,RGB10_A2UI:36975,TEXTURE_IMMUTABLE_FORMAT:37167,TEXTURE_IMMUTABLE_LEVELS:33503,UNSIGNED_INT_2_10_10_10_REV:33640,UNSIGNED_INT_10F_11F_11F_REV:35899,UNSIGNED_INT_5_9_9_9_REV:35902,FLOAT_32_UNSIGNED_INT_24_8_REV:36269,UNSIGNED_INT_24_8:34042,HALF_FLOAT:5131,RG:33319,RG_INTEGER:33320,INT_2_10_10_10_REV:36255,CURRENT_QUERY:34917,QUERY_RESULT:34918,QUERY_RESULT_AVAILABLE:34919,ANY_SAMPLES_PASSED:35887,ANY_SAMPLES_PASSED_CONSERVATIVE:36202,MAX_DRAW_BUFFERS:34852,DRAW_BUFFER0:34853,DRAW_BUFFER1:34854,DRAW_BUFFER2:34855,DRAW_BUFFER3:34856,DRAW_BUFFER4:34857,DRAW_BUFFER5:34858,DRAW_BUFFER6:34859,DRAW_BUFFER7:34860,DRAW_BUFFER8:34861,DRAW_BUFFER9:34862,DRAW_BUFFER10:34863,DRAW_BUFFER11:34864,DRAW_BUFFER12:34865,DRAW_BUFFER13:34866,DRAW_BUFFER14:34867,DRAW_BUFFER15:34868,MAX_COLOR_ATTACHMENTS:36063,COLOR_ATTACHMENT1:36065,COLOR_ATTACHMENT2:36066,COLOR_ATTACHMENT3:36067,COLOR_ATTACHMENT4:36068,COLOR_ATTACHMENT5:36069,COLOR_ATTACHMENT6:36070,COLOR_ATTACHMENT7:36071,COLOR_ATTACHMENT8:36072,COLOR_ATTACHMENT9:36073,COLOR_ATTACHMENT10:36074,COLOR_ATTACHMENT11:36075,COLOR_ATTACHMENT12:36076,COLOR_ATTACHMENT13:36077,COLOR_ATTACHMENT14:36078,COLOR_ATTACHMENT15:36079,SAMPLER_3D:35679,SAMPLER_2D_SHADOW:35682,SAMPLER_2D_ARRAY:36289,SAMPLER_2D_ARRAY_SHADOW:36292,SAMPLER_CUBE_SHADOW:36293,INT_SAMPLER_2D:36298,INT_SAMPLER_3D:36299,INT_SAMPLER_CUBE:36300,INT_SAMPLER_2D_ARRAY:36303,UNSIGNED_INT_SAMPLER_2D:36306,UNSIGNED_INT_SAMPLER_3D:36307,UNSIGNED_INT_SAMPLER_CUBE:36308,UNSIGNED_INT_SAMPLER_2D_ARRAY:36311,MAX_SAMPLES:36183,SAMPLER_BINDING:35097,PIXEL_PACK_BUFFER:35051,PIXEL_UNPACK_BUFFER:35052,PIXEL_PACK_BUFFER_BINDING:35053,PIXEL_UNPACK_BUFFER_BINDING:35055,COPY_READ_BUFFER:36662,COPY_WRITE_BUFFER:36663,COPY_READ_BUFFER_BINDING:36662,COPY_WRITE_BUFFER_BINDING:36663,FLOAT_MAT2x3:35685,FLOAT_MAT2x4:35686,FLOAT_MAT3x2:35687,FLOAT_MAT3x4:35688,FLOAT_MAT4x2:35689,FLOAT_MAT4x3:35690,UNSIGNED_INT_VEC2:36294,UNSIGNED_INT_VEC3:36295,UNSIGNED_INT_VEC4:36296,UNSIGNED_NORMALIZED:35863,SIGNED_NORMALIZED:36764,VERTEX_ATTRIB_ARRAY_INTEGER:35069,VERTEX_ATTRIB_ARRAY_DIVISOR:35070,TRANSFORM_FEEDBACK_BUFFER_MODE:35967,MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS:35968,TRANSFORM_FEEDBACK_VARYINGS:35971,TRANSFORM_FEEDBACK_BUFFER_START:35972,TRANSFORM_FEEDBACK_BUFFER_SIZE:35973,TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN:35976,MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS:35978,MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS:35979,INTERLEAVED_ATTRIBS:35980,SEPARATE_ATTRIBS:35981,TRANSFORM_FEEDBACK_BUFFER:35982,TRANSFORM_FEEDBACK_BUFFER_BINDING:35983,TRANSFORM_FEEDBACK:36386,TRANSFORM_FEEDBACK_PAUSED:36387,TRANSFORM_FEEDBACK_ACTIVE:36388,TRANSFORM_FEEDBACK_BINDING:36389,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:33296,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:33297,FRAMEBUFFER_ATTACHMENT_RED_SIZE:33298,FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:33299,FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:33300,FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:33301,FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:33302,FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:33303,FRAMEBUFFER_DEFAULT:33304,DEPTH24_STENCIL8:35056,DRAW_FRAMEBUFFER_BINDING:36006,READ_FRAMEBUFFER_BINDING:36010,RENDERBUFFER_SAMPLES:36011,FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:36052,FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:36182,UNIFORM_BUFFER:35345,UNIFORM_BUFFER_BINDING:35368,UNIFORM_BUFFER_START:35369,UNIFORM_BUFFER_SIZE:35370,MAX_VERTEX_UNIFORM_BLOCKS:35371,MAX_FRAGMENT_UNIFORM_BLOCKS:35373,MAX_COMBINED_UNIFORM_BLOCKS:35374,MAX_UNIFORM_BUFFER_BINDINGS:35375,MAX_UNIFORM_BLOCK_SIZE:35376,MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:35377,MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:35379,UNIFORM_BUFFER_OFFSET_ALIGNMENT:35380,ACTIVE_UNIFORM_BLOCKS:35382,UNIFORM_TYPE:35383,UNIFORM_SIZE:35384,UNIFORM_BLOCK_INDEX:35386,UNIFORM_OFFSET:35387,UNIFORM_ARRAY_STRIDE:35388,UNIFORM_MATRIX_STRIDE:35389,UNIFORM_IS_ROW_MAJOR:35390,UNIFORM_BLOCK_BINDING:35391,UNIFORM_BLOCK_DATA_SIZE:35392,UNIFORM_BLOCK_ACTIVE_UNIFORMS:35394,UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:35395,UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:35396,UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:35398,OBJECT_TYPE:37138,SYNC_CONDITION:37139,SYNC_STATUS:37140,SYNC_FLAGS:37141,SYNC_FENCE:37142,SYNC_GPU_COMMANDS_COMPLETE:37143,UNSIGNALED:37144,SIGNALED:37145,ALREADY_SIGNALED:37146,TIMEOUT_EXPIRED:37147,CONDITION_SATISFIED:37148,WAIT_FAILED:37149,SYNC_FLUSH_COMMANDS_BIT:1,COLOR:6144,DEPTH:6145,STENCIL:6146,MIN:32775,MAX:32776,DEPTH_COMPONENT24:33190,STREAM_READ:35041,STREAM_COPY:35042,STATIC_READ:35045,STATIC_COPY:35046,DYNAMIC_READ:35049,DYNAMIC_COPY:35050,DEPTH_COMPONENT32F:36012,DEPTH32F_STENCIL8:36013,INVALID_INDEX:4294967295,TIMEOUT_IGNORED:-1,MAX_CLIENT_WAIT_TIMEOUT_WEBGL:37447,VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE:35070,UNMASKED_VENDOR_WEBGL:37445,UNMASKED_RENDERER_WEBGL:37446,MAX_TEXTURE_MAX_ANISOTROPY_EXT:34047,TEXTURE_MAX_ANISOTROPY_EXT:34046,COMPRESSED_RGB_S3TC_DXT1_EXT:33776,COMPRESSED_RGBA_S3TC_DXT1_EXT:33777,COMPRESSED_RGBA_S3TC_DXT3_EXT:33778,COMPRESSED_RGBA_S3TC_DXT5_EXT:33779,COMPRESSED_R11_EAC:37488,COMPRESSED_SIGNED_R11_EAC:37489,COMPRESSED_RG11_EAC:37490,COMPRESSED_SIGNED_RG11_EAC:37491,COMPRESSED_RGB8_ETC2:37492,COMPRESSED_RGBA8_ETC2_EAC:37493,COMPRESSED_SRGB8_ETC2:37494,COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:37495,COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:37496,COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:37497,COMPRESSED_RGB_PVRTC_4BPPV1_IMG:35840,COMPRESSED_RGBA_PVRTC_4BPPV1_IMG:35842,COMPRESSED_RGB_PVRTC_2BPPV1_IMG:35841,COMPRESSED_RGBA_PVRTC_2BPPV1_IMG:35843,COMPRESSED_RGB_ETC1_WEBGL:36196,COMPRESSED_RGB_ATC_WEBGL:35986,COMPRESSED_RGBA_ATC_EXPLICIT_ALPHA_WEBGL:35986,COMPRESSED_RGBA_ATC_INTERPOLATED_ALPHA_WEBGL:34798,UNSIGNED_INT_24_8_WEBGL:34042,HALF_FLOAT_OES:36193,RGBA32F_EXT:34836,RGB32F_EXT:34837,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT:33297,UNSIGNED_NORMALIZED_EXT:35863,MIN_EXT:32775,MAX_EXT:32776,SRGB_EXT:35904,SRGB_ALPHA_EXT:35906,SRGB8_ALPHA8_EXT:35907,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT:33296,FRAGMENT_SHADER_DERIVATIVE_HINT_OES:35723,COLOR_ATTACHMENT0_WEBGL:36064,COLOR_ATTACHMENT1_WEBGL:36065,COLOR_ATTACHMENT2_WEBGL:36066,COLOR_ATTACHMENT3_WEBGL:36067,COLOR_ATTACHMENT4_WEBGL:36068,COLOR_ATTACHMENT5_WEBGL:36069,COLOR_ATTACHMENT6_WEBGL:36070,COLOR_ATTACHMENT7_WEBGL:36071,COLOR_ATTACHMENT8_WEBGL:36072,COLOR_ATTACHMENT9_WEBGL:36073,COLOR_ATTACHMENT10_WEBGL:36074,COLOR_ATTACHMENT11_WEBGL:36075,COLOR_ATTACHMENT12_WEBGL:36076,COLOR_ATTACHMENT13_WEBGL:36077,COLOR_ATTACHMENT14_WEBGL:36078,COLOR_ATTACHMENT15_WEBGL:36079,DRAW_BUFFER0_WEBGL:34853,DRAW_BUFFER1_WEBGL:34854,DRAW_BUFFER2_WEBGL:34855,DRAW_BUFFER3_WEBGL:34856,DRAW_BUFFER4_WEBGL:34857,DRAW_BUFFER5_WEBGL:34858,DRAW_BUFFER6_WEBGL:34859,DRAW_BUFFER7_WEBGL:34860,DRAW_BUFFER8_WEBGL:34861,DRAW_BUFFER9_WEBGL:34862,DRAW_BUFFER10_WEBGL:34863,DRAW_BUFFER11_WEBGL:34864,DRAW_BUFFER12_WEBGL:34865,DRAW_BUFFER13_WEBGL:34866,DRAW_BUFFER14_WEBGL:34867,DRAW_BUFFER15_WEBGL:34868,MAX_COLOR_ATTACHMENTS_WEBGL:36063,MAX_DRAW_BUFFERS_WEBGL:34852,VERTEX_ARRAY_BINDING_OES:34229,QUERY_COUNTER_BITS_EXT:34916,CURRENT_QUERY_EXT:34917,QUERY_RESULT_EXT:34918,QUERY_RESULT_AVAILABLE_EXT:34919,TIME_ELAPSED_EXT:35007,TIMESTAMP_EXT:36392,GPU_DISJOINT_EXT:36795}},
"ae707e931d": function _(e,t,r){Object.defineProperty(r,"__esModule",{value:!0});const n=e("@bokehjs/models/widgets/markup"),a=e("ba20932521");class s extends a.PanelMarkupView{render(){var e;super.render();const t=(e=this.model.text,(new DOMParser).parseFromString(e,"text/html").documentElement.textContent)||this.model.text;t?(this.markup_el.innerHTML=t,Array.from(this.markup_el.querySelectorAll("script")).forEach(e=>{const t=document.createElement("script");Array.from(e.attributes).forEach(e=>t.setAttribute(e.name,e.value)),t.appendChild(document.createTextNode(e.innerHTML)),e.parentNode&&e.parentNode.replaceChild(t,e)})):this.markup_el.innerHTML=""}}r.HTMLView=s,s.__name__="HTMLView";class o extends n.Markup{constructor(e){super(e)}static init_HTML(){this.prototype.default_view=s}}r.HTML=o,o.__name__="HTML",o.__module__="panel.models.markup",o.init_HTML()},
"9ba5b8422a": function _(e,t,r){Object.defineProperty(r,"__esModule",{value:!0});const s=e("tslib"),i=s.__importStar(e("@bokehjs/core/properties")),o=e("@bokehjs/models/widgets/markup"),n=s.__importDefault(e("18bba7b7e1")),a=e("ba20932521");class d extends a.PanelMarkupView{render(){super.render();const e=this.model.text.replace(/(\r\n|\n|\r)/gm,"").replace("'",'"');let t;try{t=window.JSON.parse(e)}catch(e){return void(this.markup_el.innerHTML="<b>Invalid JSON:</b> "+e.toString())}const r={hoverPreviewEnabled:this.model.hover_preview,theme:this.model.theme},s=new n.default(t,this.model.depth,r).render();let i="border-radius: 5px; padding: 10px;";"dark"==this.model.theme?s.style.cssText="background-color: rgb(30, 30, 30);"+i:s.style.cssText=i,this.markup_el.append(s)}}r.JSONView=d,d.__name__="JSONView";const l=["dark","light"];class p extends o.Markup{constructor(e){super(e)}static init_JSON(){this.prototype.default_view=d,this.define({depth:[i.Number,1],hover_preview:[i.Boolean,!1],theme:[i.Enum(l),"dark"]})}}r.JSON=p,p.__name__="JSON",p.__module__="panel.models.markup",p.init_JSON()},
"18bba7b7e1": function _(t,e,r){function n(t){return null===t?"null":typeof t}function o(t){return!!t&&"object"==typeof t}function i(t){if(void 0===t)return"";if(null===t)return"Object";if("object"==typeof t&&!t.constructor)return"Object";var e=/function ([^(]*)/.exec(t.constructor.toString());return e&&e.length>1?e[1]:""}function s(t,e,r){return"null"===t||"undefined"===t?t:("string"!==t&&"stringifiable"!==t||(r='"'+r.replace(/"/g,'\\"')+'"'),"function"===t?e.toString().replace(/[\r\n]/g,"").replace(/\{.*\}/,"")+"{…}":r)}function a(t){var e="";return o(t)?(e=i(t),Array.isArray(t)&&(e+="["+t.length+"]")):e=s(n(t),t,t),e}function f(t){return"json-formatter-"+t}function m(t,e,r){var n=document.createElement(t);return e&&n.classList.add(f(e)),void 0!==r&&(r instanceof Node?n.appendChild(r):n.appendChild(document.createTextNode(String(r)))),n}Object.defineProperty(r,"__esModule",{value:!0}),function(t){if("undefined"!=typeof window){var e=document.createElement("style");e.setAttribute("media","screen"),e.innerHTML=t,document.head.appendChild(e)}}('.json-formatter-row {\n  font-family: monospace;\n}\n.json-formatter-row,\n.json-formatter-row a,\n.json-formatter-row a:hover {\n  color: black;\n  text-decoration: none;\n}\n.json-formatter-row .json-formatter-row {\n  margin-left: 1rem;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty {\n  opacity: 0.5;\n  margin-left: 1rem;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty:after {\n  display: none;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-object:after {\n  content: "No properties";\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-array:after {\n  content: "[]";\n}\n.json-formatter-row .json-formatter-string,\n.json-formatter-row .json-formatter-stringifiable {\n  color: green;\n  white-space: pre;\n  word-wrap: break-word;\n}\n.json-formatter-row .json-formatter-number {\n  color: blue;\n}\n.json-formatter-row .json-formatter-boolean {\n  color: red;\n}\n.json-formatter-row .json-formatter-null {\n  color: #855A00;\n}\n.json-formatter-row .json-formatter-undefined {\n  color: #ca0b69;\n}\n.json-formatter-row .json-formatter-function {\n  color: #FF20ED;\n}\n.json-formatter-row .json-formatter-date {\n  background-color: rgba(0, 0, 0, 0.05);\n}\n.json-formatter-row .json-formatter-url {\n  text-decoration: underline;\n  color: blue;\n  cursor: pointer;\n}\n.json-formatter-row .json-formatter-bracket {\n  color: blue;\n}\n.json-formatter-row .json-formatter-key {\n  color: #00008B;\n  padding-right: 0.2rem;\n}\n.json-formatter-row .json-formatter-toggler-link {\n  cursor: pointer;\n}\n.json-formatter-row .json-formatter-toggler {\n  line-height: 1.2rem;\n  font-size: 0.7rem;\n  vertical-align: middle;\n  opacity: 0.6;\n  cursor: pointer;\n  padding-right: 0.2rem;\n}\n.json-formatter-row .json-formatter-toggler:after {\n  display: inline-block;\n  transition: transform 100ms ease-in;\n  content: "►";\n}\n.json-formatter-row > a > .json-formatter-preview-text {\n  opacity: 0;\n  transition: opacity 0.15s ease-in;\n  font-style: italic;\n}\n.json-formatter-row:hover > a > .json-formatter-preview-text {\n  opacity: 0.6;\n}\n.json-formatter-row.json-formatter-open > .json-formatter-toggler-link .json-formatter-toggler:after {\n  transform: rotate(90deg);\n}\n.json-formatter-row.json-formatter-open > .json-formatter-children:after {\n  display: inline-block;\n}\n.json-formatter-row.json-formatter-open > a > .json-formatter-preview-text {\n  display: none;\n}\n.json-formatter-row.json-formatter-open.json-formatter-empty:after {\n  display: block;\n}\n.json-formatter-dark.json-formatter-row {\n  font-family: monospace;\n}\n.json-formatter-dark.json-formatter-row,\n.json-formatter-dark.json-formatter-row a,\n.json-formatter-dark.json-formatter-row a:hover {\n  color: white;\n  text-decoration: none;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-row {\n  margin-left: 1rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty {\n  opacity: 0.5;\n  margin-left: 1rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty:after {\n  display: none;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-object:after {\n  content: "No properties";\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-array:after {\n  content: "[]";\n}\n.json-formatter-dark.json-formatter-row .json-formatter-string,\n.json-formatter-dark.json-formatter-row .json-formatter-stringifiable {\n  color: #31F031;\n  white-space: pre;\n  word-wrap: break-word;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-number {\n  color: #66C2FF;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-boolean {\n  color: #EC4242;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-null {\n  color: #EEC97D;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-undefined {\n  color: #ef8fbe;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-function {\n  color: #FD48CB;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-date {\n  background-color: rgba(255, 255, 255, 0.05);\n}\n.json-formatter-dark.json-formatter-row .json-formatter-url {\n  text-decoration: underline;\n  color: #027BFF;\n  cursor: pointer;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-bracket {\n  color: #9494FF;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-key {\n  color: #23A0DB;\n  padding-right: 0.2rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler-link {\n  cursor: pointer;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler {\n  line-height: 1.2rem;\n  font-size: 0.7rem;\n  vertical-align: middle;\n  opacity: 0.6;\n  cursor: pointer;\n  padding-right: 0.2rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler:after {\n  display: inline-block;\n  transition: transform 100ms ease-in;\n  content: "►";\n}\n.json-formatter-dark.json-formatter-row > a > .json-formatter-preview-text {\n  opacity: 0;\n  transition: opacity 0.15s ease-in;\n  font-style: italic;\n}\n.json-formatter-dark.json-formatter-row:hover > a > .json-formatter-preview-text {\n  opacity: 0.6;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > .json-formatter-toggler-link .json-formatter-toggler:after {\n  transform: rotate(90deg);\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > .json-formatter-children:after {\n  display: inline-block;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > a > .json-formatter-preview-text {\n  display: none;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open.json-formatter-empty:after {\n  display: block;\n}\n');var l=/(^\d{1,4}[\.|\\/|-]\d{1,2}[\.|\\/|-]\d{1,4})(\s*(?:0?[1-9]:[0-5]|1(?=[012])\d:[0-5])\d\s*[ap]m)?$/,d=/\d{2}:\d{2}:\d{2} GMT-\d{4}/,c=/\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.\d{3}Z/,p=window.requestAnimationFrame||function(t){return t(),0},j={hoverPreviewEnabled:!1,hoverPreviewArrayCount:100,hoverPreviewFieldCount:5,animateOpen:!0,animateClose:!0,theme:null,useToJSON:!0,sortPropertiesBy:null},h=function(){function t(t,e,r,n){void 0===e&&(e=1),void 0===r&&(r=j),this.json=t,this.open=e,this.config=r,this.key=n,this._isOpen=null,void 0===this.config.hoverPreviewEnabled&&(this.config.hoverPreviewEnabled=j.hoverPreviewEnabled),void 0===this.config.hoverPreviewArrayCount&&(this.config.hoverPreviewArrayCount=j.hoverPreviewArrayCount),void 0===this.config.hoverPreviewFieldCount&&(this.config.hoverPreviewFieldCount=j.hoverPreviewFieldCount),void 0===this.config.useToJSON&&(this.config.useToJSON=j.useToJSON),""===this.key&&(this.key='""')}return Object.defineProperty(t.prototype,"isOpen",{get:function(){return null!==this._isOpen?this._isOpen:this.open>0},set:function(t){this._isOpen=t},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isDate",{get:function(){return this.json instanceof Date||"string"===this.type&&(l.test(this.json)||c.test(this.json)||d.test(this.json))},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isUrl",{get:function(){return"string"===this.type&&0===this.json.indexOf("http")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isArray",{get:function(){return Array.isArray(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isObject",{get:function(){return o(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isEmptyObject",{get:function(){return!this.keys.length&&!this.isArray},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isEmpty",{get:function(){return this.isEmptyObject||this.keys&&!this.keys.length&&this.isArray},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"useToJSON",{get:function(){return this.config.useToJSON&&"stringifiable"===this.type},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hasKey",{get:function(){return void 0!==this.key},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"constructorName",{get:function(){return i(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"type",{get:function(){return this.config.useToJSON&&this.json&&this.json.toJSON?"stringifiable":n(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"keys",{get:function(){if(this.isObject){var t=Object.keys(this.json);return!this.isArray&&this.config.sortPropertiesBy?t.sort(this.config.sortPropertiesBy):t}return[]},enumerable:!0,configurable:!0}),t.prototype.toggleOpen=function(){this.isOpen=!this.isOpen,this.element&&(this.isOpen?this.appendChildren(this.config.animateOpen):this.removeChildren(this.config.animateClose),this.element.classList.toggle(f("open")))},t.prototype.openAtDepth=function(t){void 0===t&&(t=1),t<0||(this.open=t,this.isOpen=0!==t,this.element&&(this.removeChildren(!1),0===t?this.element.classList.remove(f("open")):(this.appendChildren(this.config.animateOpen),this.element.classList.add(f("open")))))},t.prototype.getInlinepreview=function(){var t=this;if(this.isArray)return this.json.length>this.config.hoverPreviewArrayCount?"Array["+this.json.length+"]":"["+this.json.map(a).join(", ")+"]";var e=this.keys,r=e.slice(0,this.config.hoverPreviewFieldCount).map((function(e){return e+":"+a(t.json[e])})),n=e.length>=this.config.hoverPreviewFieldCount?"…":"";return"{"+r.join(", ")+n+"}"},t.prototype.render=function(){this.element=m("div","row");var t=this.isObject?m("a","toggler-link"):m("span");if(this.isObject&&!this.useToJSON&&t.appendChild(m("span","toggler")),this.hasKey&&t.appendChild(m("span","key",this.key+":")),this.isObject&&!this.useToJSON){var e=m("span","value"),r=m("span"),n=m("span","constructor-name",this.constructorName);if(r.appendChild(n),this.isArray){var o=m("span");o.appendChild(m("span","bracket","[")),o.appendChild(m("span","number",this.json.length)),o.appendChild(m("span","bracket","]")),r.appendChild(o)}e.appendChild(r),t.appendChild(e)}else{(e=this.isUrl?m("a"):m("span")).classList.add(f(this.type)),this.isDate&&e.classList.add(f("date")),this.isUrl&&(e.classList.add(f("url")),e.setAttribute("href",this.json));var i=s(this.type,this.json,this.useToJSON?this.json.toJSON():this.json);e.appendChild(document.createTextNode(i)),t.appendChild(e)}if(this.isObject&&this.config.hoverPreviewEnabled){var a=m("span","preview-text");a.appendChild(document.createTextNode(this.getInlinepreview())),t.appendChild(a)}var l=m("div","children");return this.isObject&&l.classList.add(f("object")),this.isArray&&l.classList.add(f("array")),this.isEmpty&&l.classList.add(f("empty")),this.config&&this.config.theme&&this.element.classList.add(f(this.config.theme)),this.isOpen&&this.element.classList.add(f("open")),this.element.appendChild(t),this.element.appendChild(l),this.isObject&&this.isOpen&&this.appendChildren(),this.isObject&&!this.useToJSON&&t.addEventListener("click",this.toggleOpen.bind(this)),this.element},t.prototype.appendChildren=function(e){var r=this;void 0===e&&(e=!1);var n=this.element.querySelector("div."+f("children"));if(n&&!this.isEmpty)if(e){var o=0,i=function(){var e=r.keys[o],s=new t(r.json[e],r.open-1,r.config,e);n.appendChild(s.render()),(o+=1)<r.keys.length&&(o>10?i():p(i))};p(i)}else this.keys.forEach((function(e){var o=new t(r.json[e],r.open-1,r.config,e);n.appendChild(o.render())}))},t.prototype.removeChildren=function(t){void 0===t&&(t=!1);var e=this.element.querySelector("div."+f("children"));if(t){var r=0,n=function(){e&&e.children.length&&(e.removeChild(e.children[0]),(r+=1)>10?n():p(n))};p(n)}else e&&(e.innerHTML="")},t}();r.default=h},
"a94e371ba4": function _(e,t,i){Object.defineProperty(i,"__esModule",{value:!0});const l=e("tslib"),n=e("@bokehjs/models/widgets/input_widget"),s=e("@bokehjs/styles/buttons"),o=l.__importStar(e("@bokehjs/core/properties"));class a extends n.InputWidgetView{constructor(){super(...arguments),this._initialized=!1}connect_signals(){super.connect_signals(),this.connect(this.model.properties.button_type.change,()=>this.render()),this.connect(this.model.properties.data.change,()=>this.render()),this.connect(this.model.properties.filename.change,()=>this.render()),this.connect(this.model.properties.label.change,()=>this._update_label())}render(){if(super.render(),this.anchor_el=document.createElement("a"),this.anchor_el.classList.add(s.bk_btn),this.anchor_el.classList.add(s.bk_btn_type(this.model.button_type)),this.anchor_el.textContent=this.model.label,null===this.model.data||null===this.model.filename)return this.anchor_el.addEventListener("click",()=>this.click()),this.group_el.appendChild(this.anchor_el),void(this._initialized=!0);const e=function(e){const t=atob(e.split(",")[1]),i=e.split(",")[0].split(":")[1].split(";")[0],l=new ArrayBuffer(t.length),n=new Uint8Array(l);for(let e=0;e<t.length;e++)n[e]=t.charCodeAt(e);return new Blob([l],{type:i})}(this.model.data),t=URL.createObjectURL(e);this.anchor_el.href=t,this.anchor_el.download=this.model.filename,this.group_el.appendChild(this.anchor_el),this.model.auto&&this._initialized&&this.anchor_el.click(),this._initialized=!0}_update_label(){this.anchor_el.textContent=this.model.label}click(){this.model.clicks=this.model.clicks+1}}i.FileDownloadView=a,a.__name__="FileDownloadView";class r extends n.InputWidget{constructor(e){super(e)}static init_FileDownload(){this.prototype.default_view=a,this.define({auto:[o.Boolean,!1],clicks:[o.Number,0],data:[o.String,null],label:[o.String,"Download"],filename:[o.String,null],button_type:[o.ButtonType,"default"]}),this.override({title:""})}}i.FileDownload=r,r.__name__="FileDownload",r.__module__="panel.models.widgets",r.init_FileDownload()},
"7b859fb3cf": function _(e,t,i){Object.defineProperty(i,"__esModule",{value:!0});const a=e("@bokehjs/models/widgets/markup"),n=e("ba20932521");class r extends n.PanelMarkupView{render(){super.render(),this.markup_el.innerHTML=this.model.text,window.renderMathInElement&&window.renderMathInElement(this.el,{delimiters:[{left:"$$",right:"$$",display:!0},{left:"\\[",right:"\\]",display:!0},{left:"$",right:"$",display:!1},{left:"\\(",right:"\\)",display:!1}]})}}i.KaTeXView=r,r.__name__="KaTeXView";class s extends a.Markup{constructor(e){super(e)}static init_KaTeX(){this.prototype.default_view=r}}i.KaTeX=s,s.__name__="KaTeX",s.__module__="panel.models.katex",s.init_KaTeX()},
"0c21036737": function _(e,t,a){Object.defineProperty(a,"__esModule",{value:!0});const i=e("@bokehjs/models/widgets/markup"),s=e("ba20932521");class _ extends s.PanelMarkupView{initialize(){super.initialize(),this._hub=window.MathJax.Hub,this._hub.Config({tex2jax:{inlineMath:[["$","$"],["\\(","\\)"]]}})}render(){super.render(),this._hub&&(this.markup_el.innerHTML=this.model.text,this._hub.Queue(["Typeset",this._hub,this.markup_el]))}}a.MathJaxView=_,_.__name__="MathJaxView";class h extends i.Markup{constructor(e){super(e)}static init_MathJax(){this.prototype.default_view=_}}a.MathJax=h,h.__name__="MathJax",h.__module__="panel.models.mathjax",h.init_MathJax()},
"000f20fdd3": function _(e,t,i){Object.defineProperty(i,"__esModule",{value:!0});const s=e("tslib").__importStar(e("@bokehjs/core/properties")),n=e("@bokehjs/core/dom"),l=e("@bokehjs/models/widgets/widget");class a extends l.WidgetView{connect_signals(){super.connect_signals(),this.connect(this.model.change,()=>this.render()),this.connect(this.model.properties.value.change,()=>this.render()),this.connect(this.model.properties.loop_policy.change,()=>this.set_loop_state(this.model.loop_policy))}get_height(){return 250}render(){if(null!=this.sliderEl)return this.sliderEl.style.width="{this.model.width}px",this.sliderEl.min=String(this.model.start),this.sliderEl.max=String(this.model.end),void(this.sliderEl.value=String(this.model.value));super.render(),this.sliderEl=document.createElement("input"),this.sliderEl.setAttribute("type","range"),this.sliderEl.style.width=this.model.width+"px",this.sliderEl.value=String(this.model.value),this.sliderEl.min=String(this.model.start),this.sliderEl.max=String(this.model.end),this.sliderEl.onchange=e=>this.set_frame(parseInt(e.target.value));const e=n.div();e.style.cssText="margin: 0 auto; display: table; padding: 5px";const t="text-align: center; min-width: 40px; margin: 2px",i=document.createElement("button");i.style.cssText="text-align: center; min-width: 20px",i.appendChild(document.createTextNode("–")),i.onclick=()=>this.slower(),e.appendChild(i);const s=document.createElement("button");s.style.cssText=t,s.appendChild(document.createTextNode("❚◀◀")),s.onclick=()=>this.first_frame(),e.appendChild(s);const l=document.createElement("button");l.style.cssText=t,l.appendChild(document.createTextNode("❚◀")),l.onclick=()=>this.previous_frame(),e.appendChild(l);const a=document.createElement("button");a.style.cssText=t,a.appendChild(document.createTextNode("◀")),a.onclick=()=>this.reverse_animation(),e.appendChild(a);const o=document.createElement("button");o.style.cssText=t,o.appendChild(document.createTextNode("❚❚")),o.onclick=()=>this.pause_animation(),e.appendChild(o);const r=document.createElement("button");r.style.cssText=t,r.appendChild(document.createTextNode("▶")),r.onclick=()=>this.play_animation(),e.appendChild(r);const d=document.createElement("button");d.style.cssText=t,d.appendChild(document.createTextNode("▶❚")),d.onclick=()=>this.next_frame(),e.appendChild(d);const h=document.createElement("button");h.style.cssText=t,h.appendChild(document.createTextNode("▶▶❚")),h.onclick=()=>this.last_frame(),e.appendChild(h);const c=document.createElement("button");c.style.cssText="text-align: center; min-width: 20px",c.appendChild(document.createTextNode("+")),c.onclick=()=>this.faster(),e.appendChild(c),this.loop_state=document.createElement("form"),this.loop_state.style.cssText="margin: 0 auto; display: table";const m=document.createElement("input");m.type="radio",m.value="once",m.name="state";const p=document.createElement("label");p.innerHTML="Once",p.style.cssText="padding: 0 10px 0 5px; user-select:none;";const u=document.createElement("input");u.setAttribute("type","radio"),u.setAttribute("value","loop"),u.setAttribute("name","state");const _=document.createElement("label");_.innerHTML="Loop",_.style.cssText="padding: 0 10px 0 5px; user-select:none;";const v=document.createElement("input");v.setAttribute("type","radio"),v.setAttribute("value","reflect"),v.setAttribute("name","state");const x=document.createElement("label");x.innerHTML="Reflect",x.style.cssText="padding: 0 10px 0 5px; user-select:none;","once"==this.model.loop_policy?m.checked=!0:"loop"==this.model.loop_policy?u.checked=!0:v.checked=!0,this.loop_state.appendChild(m),this.loop_state.appendChild(p),this.loop_state.appendChild(u),this.loop_state.appendChild(_),this.loop_state.appendChild(v),this.loop_state.appendChild(x),this.el.appendChild(this.sliderEl),this.el.appendChild(e),this.el.appendChild(this.loop_state)}set_frame(e){this.model.value!=e&&(this.model.value=e),this.sliderEl.value!=String(e)&&(this.sliderEl.value=String(e))}get_loop_state(){for(var e=this.loop_state.state,t=0;t<e.length;t++){var i=e[t];if(i.checked)return i.value}return"once"}set_loop_state(e){for(var t=this.loop_state.state,i=0;i<t.length;i++){var s=t[i];s.value==e&&(s.checked=!0)}}next_frame(){this.set_frame(Math.min(this.model.end,this.model.value+this.model.step))}previous_frame(){this.set_frame(Math.max(this.model.start,this.model.value-this.model.step))}first_frame(){this.set_frame(this.model.start)}last_frame(){this.set_frame(this.model.end)}slower(){this.model.interval=Math.round(this.model.interval/.7),this.model.direction>0?this.play_animation():this.model.direction<0&&this.reverse_animation()}faster(){this.model.interval=Math.round(.7*this.model.interval),this.model.direction>0?this.play_animation():this.model.direction<0&&this.reverse_animation()}anim_step_forward(){if(this.model.value<this.model.end)this.next_frame();else{var e=this.get_loop_state();"loop"==e?this.first_frame():"reflect"==e?(this.last_frame(),this.reverse_animation()):(this.pause_animation(),this.last_frame())}}anim_step_reverse(){if(this.model.value>this.model.start)this.previous_frame();else{var e=this.get_loop_state();"loop"==e?this.last_frame():"reflect"==e?(this.first_frame(),this.play_animation()):(this.pause_animation(),this.first_frame())}}pause_animation(){this.model.direction=0,this.timer&&(clearInterval(this.timer),this.timer=null)}play_animation(){this.pause_animation(),this.model.direction=1,this.timer||(this.timer=setInterval(()=>this.anim_step_forward(),this.model.interval))}reverse_animation(){this.pause_animation(),this.model.direction=-1,this.timer||(this.timer=setInterval(()=>this.anim_step_reverse(),this.model.interval))}}i.PlayerView=a,a.__name__="PlayerView";class o extends l.Widget{constructor(e){super(e)}static init_Player(){this.prototype.default_view=a,this.define({direction:[s.Number,0],interval:[s.Number,500],start:[s.Number],end:[s.Number],step:[s.Number,1],loop_policy:[s.Any,"once"],value:[s.Any,0]}),this.override({width:400})}}i.Player=o,o.__name__="Player",o.__module__="panel.models.widgets",o.init_Player()},
"2363c12dd6": function _(t,e,o){Object.defineProperty(o,"__esModule",{value:!0});const i=t("tslib").__importStar(t("@bokehjs/core/properties")),l=t("@bokehjs/core/util/object"),r=t("@bokehjs/core/util/eq"),s=t("@bokehjs/models/layouts/html_box"),n=t("99a25e6992"),a=t("990b5dd5c7"),p=t("ba20932521"),h=window.Plotly,_=(t,e,o)=>{let i=Array.isArray(e)?[]:{};if("click"===o||"hover"===o||"selected"===o){const o=[];if(null==e)return null;const l=t.data;for(let t=0;t<e.points.length;t++){const i=e.points[t];let r={};for(let t in i){const e=i[t];!i.hasOwnProperty(t)||Array.isArray(e)||a.isPlainObject(e)||(r[t]=e)}null!=i&&(i.hasOwnProperty("curveNumber")&&i.hasOwnProperty("pointNumber")&&l[i.curveNumber].hasOwnProperty("customdata")&&(r.customdata=l[i.curveNumber].customdata[i.pointNumber]),i.hasOwnProperty("pointNumbers")&&(r.pointNumbers=i.pointNumbers)),o[t]=r}i.points=o}else if("relayout"===o||"restyle"===o)for(let t in e)e.hasOwnProperty(t)&&(i[t]=e[t]);return e.hasOwnProperty("range")&&(i.range=e.range),e.hasOwnProperty("lassoPoints")&&(i.lassoPoints=e.lassoPoints),i};class u extends p.PanelHTMLBoxView{constructor(){super(...arguments),this._settingViewport=!1,this._plotInitialized=!1,this._reacting=!1,this._relayouting=!1,this._end_relayouting=n.debounce(()=>{this._relayouting=!1},2e3,!1)}connect_signals(){super.connect_signals(),this.connect(this.model.properties.viewport_update_policy.change,this._updateSetViewportFunction),this.connect(this.model.properties.viewport_update_throttle.change,this._updateSetViewportFunction),this.connect(this.model.properties._render_count.change,this.plot),this.connect(this.model.properties.viewport.change,this._updateViewportFromProperty)}render(){super.render(),window.Plotly&&this.plot()}plot(){if(!window.Plotly)return;const t=[];for(let e=0;e<this.model.data.length;e++)t.push(this._get_trace(e,!1));let e=a.deepCopy(this.model.layout);if(this._relayouting){const t=this.el.layout;Object.keys(t).reduce((t,o)=>{"axis"===o.slice(1,5)&&"range"in t&&(e[o].range=t.range)},{})}this._reacting=!0,h.react(this.el,t,e,this.model.config).then(()=>{this._updateSetViewportFunction(),this._updateViewportProperty(),this._plotInitialized||(this.el.on("plotly_relayout",t=>{!0!==t._update_from_property&&(this.model.relayout_data=_(this.el,t,"relayout"),this._updateViewportProperty(),this._end_relayouting())}),this.el.on("plotly_relayouting",()=>{"mouseup"!==this.model.viewport_update_policy&&(this._relayouting=!0,this._updateViewportProperty())}),this.el.on("plotly_restyle",t=>{this.model.restyle_data=_(this.el,t,"restyle"),this._updateViewportProperty()}),this.el.on("plotly_click",t=>{this.model.click_data=_(this.el,t,"click")}),this.el.on("plotly_hover",t=>{this.model.hover_data=_(this.el,t,"hover")}),this.el.on("plotly_selected",t=>{this.model.selected_data=_(this.el,t,"selected")}),this.el.on("plotly_clickannotation",t=>{delete t.event,delete t.fullAnnotation,this.model.clickannotation_data=t}),this.el.on("plotly_deselect",()=>{this.model.selected_data=null}),this.el.on("plotly_unhover",()=>{this.model.hover_data=null})),this._plotInitialized=!0,this._reacting=!1})}_get_trace(t,e){const o=l.clone(this.model.data[t]),i=this.model.data_sources[t];for(const t of i.columns()){const l=i._shapes[t][0];let s=i.get_array(t)[0];if(l.length>1){const t=[];for(let e=0;e<l[0];e++)t.push(s.slice(e*l[1],(e+1)*l[1]));s=t}let n=t.split("."),a=n[n.length-1];var r=o;for(let t of n.slice(0,-1))r=r[t];e&&1==n.length?r[a]=[s]:r[a]=s}return o}_updateViewportFromProperty(){if(!h||this._settingViewport||this._reacting||!this.model.viewport)return;const t=this.el._fullLayout;Object.keys(this.model.viewport).reduce((e,o)=>{if(r.isEqual(a.get(t,o),e))return!0;{let t=a.deepCopy(this.model.viewport);return t._update_from_property=!0,h.relayout(this.el,t),!1}},{})}_updateViewportProperty(){const t=this.el._fullLayout;let e={};for(let o in t){if(!t.hasOwnProperty(o))continue;let i=o.slice(0,5);"xaxis"!==i&&"yaxis"!==i||(e[o+".range"]=a.deepCopy(t[o].range))}r.isEqual(e,this.model.viewport)||this._setViewport(e)}_updateSetViewportFunction(){"continuous"===this.model.viewport_update_policy||"mouseup"===this.model.viewport_update_policy?this._setViewport=t=>{this._settingViewport||(this._settingViewport=!0,this.model.viewport=t,this._settingViewport=!1)}:this._setViewport=a.throttle(t=>{this._settingViewport||(this._settingViewport=!0,this.model.viewport=t,this._settingViewport=!1)},this.model.viewport_update_throttle)}}o.PlotlyPlotView=u,u.__name__="PlotlyPlotView";class d extends s.HTMLBox{constructor(t){super(t)}static init_PlotlyPlot(){this.prototype.default_view=u,this.define({data:[i.Array,[]],layout:[i.Any,{}],config:[i.Any,{}],data_sources:[i.Array,[]],relayout_data:[i.Any,{}],restyle_data:[i.Array,[]],click_data:[i.Any,{}],hover_data:[i.Any,{}],clickannotation_data:[i.Any,{}],selected_data:[i.Any,{}],viewport:[i.Any,{}],viewport_update_policy:[i.String,"mouseup"],viewport_update_throttle:[i.Number,200],_render_count:[i.Number,0]})}}o.PlotlyPlot=d,d.__name__="PlotlyPlot",d.__module__="panel.models.plotly",d.init_PlotlyPlot()},
"99a25e6992": function _(n,l,u){function t(n,l,u){var t,e,o,a,r;function i(){var c=Date.now()-a;c<l&&c>=0?t=setTimeout(i,l-c):(t=null,u||(r=n.apply(o,e),o=e=null))}null==l&&(l=100);var c=function(){o=this,e=arguments,a=Date.now();var c=u&&!t;return t||(t=setTimeout(i,l)),c&&(r=n.apply(o,e),o=e=null),r};return c.clear=function(){t&&(clearTimeout(t),t=null)},c.flush=function(){t&&(r=n.apply(o,e),o=e=null,clearTimeout(t),t=null)},c}t.debounce=t,l.exports=t},
"990b5dd5c7": function _(t,e,n){Object.defineProperty(n,"__esModule",{value:!0}),n.get=(t,e,n)=>{const r=n=>String.prototype.split.call(e,n).filter(Boolean).reduce((t,e)=>null!=t?t[e]:t,t),o=r(/[,[\]]+?/)||r(/[,[\].]+?/);return void 0===o||o===t?n:o},n.throttle=function(t,e){var n=0;return function(){var r=Number(new Date);r-n>=e&&(t(),n=r)}},n.deepCopy=function t(e){var n;if(null==e||"object"!=typeof e)return e;if(e instanceof Array){n=[];for(var r=0,o=e.length;r<o;r++)n[r]=t(e[r]);return n}if(e instanceof Object){const n={};for(const r in e){const o=r;e.hasOwnProperty(o)&&(n[o]=t(e[o]))}return n}throw new Error("Unable to copy obj! Its type isn't supported.")},n.isPlainObject=function(t){return"[object Object]"===Object.prototype.toString.call(t)}},
"76307e5afa": function _(e,s,t){Object.defineProperty(t,"__esModule",{value:!0});const i=e("tslib").__importStar(e("@bokehjs/core/properties")),o=e("@bokehjs/models/layouts/html_box"),r=e("ba20932521");class l extends o.HTMLBoxView{connect_signals(){super.connect_signals();const e=()=>{this.render(),this.root.compute_layout()};this.connect(this.model.properties.height.change,e),this.connect(this.model.properties.width.change,e),this.connect(this.model.properties.height_policy.change,e),this.connect(this.model.properties.width_policy.change,e),this.connect(this.model.properties.sizing_mode.change,e),this.connect(this.model.properties.active.change,()=>this.setCSS()),this.connect(this.model.properties.bar_color.change,()=>this.setCSS()),this.connect(this.model.properties.css_classes.change,()=>this.setCSS()),this.connect(this.model.properties.value.change,()=>this.setValue()),this.connect(this.model.properties.max.change,()=>this.setMax())}render(){super.render();const e=Object.assign(Object.assign({},this.model.style),{display:"inline-block"});this.progressEl=document.createElement("progress"),this.setValue(),this.setMax(),r.set_size(this.progressEl,this.model),this.setCSS();for(const s in e)this.progressEl.style.setProperty(s,e[s]);this.el.appendChild(this.progressEl)}setCSS(){let e=this.model.css_classes.join(" ")+" "+this.model.bar_color;this.model.active&&(e+=" active"),this.progressEl.className=e}setValue(){null!=this.model.value&&(this.progressEl.value=this.model.value)}setMax(){null!=this.model.max&&(this.progressEl.max=this.model.max)}_update_layout(){let e=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new r.CachedVariadicBox(this.el,this.model.sizing_mode,e),this.layout.set_sizing(this.box_sizing())}}t.ProgressView=l,l.__name__="ProgressView";class h extends o.HTMLBox{constructor(e){super(e)}static init_Progress(){this.prototype.default_view=l,this.define({active:[i.Boolean,!0],bar_color:[i.String,"primary"],style:[i.Any,{}],max:[i.Number,100],value:[i.Number,null]})}}t.Progress=h,h.__name__="Progress",h.__module__="panel.models.widgets",h.init_Progress()},
"38b2bc9574": function _(e,t,s){Object.defineProperty(s,"__esModule",{value:!0});const i=e("tslib").__importStar(e("@bokehjs/core/properties")),a=e("@bokehjs/core/view"),o=e("@bokehjs/core/util/array"),c=e("@bokehjs/model"),n=e("@bokehjs/protocol/receiver");class r extends a.View{renderTo(){}}s.StateView=r,r.__name__="StateView";class _ extends c.Model{constructor(e){super(e),this._receiver=new n.Receiver,this._cache={}}apply_state(e){this._receiver.consume(e.header),this._receiver.consume(e.metadata),this._receiver.consume(e.content),this._receiver.message&&this.document&&this.document.apply_json_patch(this._receiver.message.content)}_receive_json(e,t){const s=JSON.parse(e);this._cache[t]=s;let i=this.state;for(const e of this.values)i=i[e];i===t?this.apply_state(s):this._cache[i]&&this.apply_state(this._cache[i])}set_state(e,t){let s=o.copy(this.values);s[this.widgets[e.id]]=t;let i=this.state;for(const e of s)i=i[e];var a,c,n;this.values=s,this.json?this._cache[i]?this.apply_state(this._cache[i]):(a=i,c=e=>this._receive_json(e,i),(n=new XMLHttpRequest).overrideMimeType("application/json"),n.open("GET",a,!0),n.onreadystatechange=function(){4==n.readyState&&200==n.status&&c(n.responseText)},n.send(null)):this.apply_state(i)}static init_State(){this.prototype.default_view=r,this.define({json:[i.Boolean,!1],state:[i.Any,{}],widgets:[i.Any,{}],values:[i.Any,[]]})}}s.State=_,_.__name__="State",_.__module__="panel.models.state",_.init_State()},
"90d1f929bd": function _(t,e,s){Object.defineProperty(s,"__esModule",{value:!0});const o=t("tslib").__importStar(t("@bokehjs/core/properties")),a=t("@bokehjs/core/util/types"),n=t("@bokehjs/models/layouts/html_box");class c extends n.HTMLBoxView{connect_signals(){super.connect_signals(),this.connect(this.model.properties.data.change,this._plot),this.connect(this.model.properties.data_sources.change,()=>this._connect_sources()),this._connected=[],this._connect_sources()}_connect_sources(){for(const t in this.model.data_sources){const e=this.model.data_sources[t];this._connected.indexOf(t)<0&&(this.connect(e.properties.data.change,this._plot),this._connected.push(t))}}_fetch_datasets(){const t={};for(const e in this.model.data_sources){const s=this.model.data_sources[e],o=[],a=s.columns();for(let t=0;t<s.data[a[0]].length;t++){const e={};for(const o of a)e[o]=s.data[o][t];o.push(e)}t[e]=o}return t}render(){super.render(),this._plot()}_plot(){const t=this.model.data;if(null!=t&&window.vegaEmbed){if(this.model.data_sources&&Object.keys(this.model.data_sources).length>0){const e=this._fetch_datasets();if("data"in e&&(t.data.values=e.data,delete e.data),null!=t.data){const s=a.isArray(t.data)?t.data:[t.data];for(const t of s)t.name in e&&(t.values=e[t.name],delete e[t.name])}this.model.data.datasets=e}window.vegaEmbed(this.el,this.model.data,{actions:!1})}}}s.VegaPlotView=c,c.__name__="VegaPlotView";class d extends n.HTMLBox{constructor(t){super(t)}static init_VegaPlot(){this.prototype.default_view=c,this.define({data:[o.Any],data_sources:[o.Any]})}}s.VegaPlot=d,d.__name__="VegaPlot",d.__module__="panel.models.vega",d.init_VegaPlot()},
"b0c3e9e9c2": function _(e,i,t){Object.defineProperty(t,"__esModule",{value:!0});const o=e("tslib").__importStar(e("@bokehjs/core/properties")),s=e("@bokehjs/models/layouts/html_box"),l=e("ba20932521");class d extends l.PanelHTMLBoxView{initialize(){super.initialize(),this._blocked=!1,this._setting=!1,this._time=Date.now()}connect_signals(){super.connect_signals(),this.connect(this.model.properties.loop.change,()=>this.set_loop()),this.connect(this.model.properties.paused.change,()=>this.set_paused()),this.connect(this.model.properties.time.change,()=>this.set_time()),this.connect(this.model.properties.value.change,()=>this.set_value()),this.connect(this.model.properties.volume.change,()=>this.set_volume())}render(){super.render(),this.videoEl=document.createElement("video"),this.model.sizing_mode&&"fixed"!==this.model.sizing_mode||(this.model.height&&(this.videoEl.height=this.model.height),this.model.width&&(this.videoEl.width=this.model.width)),this.videoEl.style.objectFit="fill",this.videoEl.style.minWidth="100%",this.videoEl.style.minHeight="100%",this.videoEl.controls=!0,this.videoEl.src=this.model.value,this.videoEl.currentTime=this.model.time,this.videoEl.loop=this.model.loop,null!=this.model.volume?this.videoEl.volume=this.model.volume/100:this.model.volume=100*this.videoEl.volume,this.videoEl.onpause=()=>this.model.paused=!0,this.videoEl.onplay=()=>this.model.paused=!1,this.videoEl.ontimeupdate=()=>this.update_time(this),this.videoEl.onvolumechange=()=>this.update_volume(this),this.el.appendChild(this.videoEl),this.model.paused||this.videoEl.play()}update_time(e){e._setting?e._setting=!1:Date.now()-e._time<e.model.throttle||(e._blocked=!0,e.model.time=e.videoEl.currentTime,e._time=Date.now())}update_volume(e){e._setting?e._setting=!1:(e._blocked=!0,e.model.volume=100*e.videoEl.volume)}set_loop(){this.videoEl.loop=this.model.loop}set_paused(){!this.videoEl.paused&&this.model.paused&&this.videoEl.pause(),this.videoEl.paused&&!this.model.paused&&this.videoEl.play()}set_volume(){this._blocked?this._blocked=!1:(this._setting=!0,null!=this.model.volume&&(this.videoEl.volume=this.model.volume/100))}set_time(){this._blocked?this._blocked=!1:(this._setting=!0,this.videoEl.currentTime=this.model.time)}set_value(){this.videoEl.src=this.model.value}}t.VideoView=d,d.__name__="VideoView";class h extends s.HTMLBox{constructor(e){super(e)}static init_Video(){this.prototype.default_view=d,this.define({loop:[o.Boolean,!1],paused:[o.Boolean,!0],time:[o.Number,0],throttle:[o.Number,250],value:[o.Any,""],volume:[o.Number,null]})}}t.Video=h,h.__name__="Video",h.__module__="panel.models.widgets",h.init_Video()},
"3c7145a2fa": function _(e,t,i){Object.defineProperty(i,"__esModule",{value:!0});const s=e("tslib").__importStar(e("@bokehjs/core/properties")),o=e("@bokehjs/models/layouts/html_box"),h=e("ba20932521");class a extends h.PanelHTMLBoxView{constructor(){super(...arguments),this.constraints={audio:!1,video:!0}}initialize(){super.initialize(),null!==this.model.timeout&&this.set_timeout()}connect_signals(){super.connect_signals(),this.connect(this.model.properties.timeout.change,()=>this.set_timeout()),this.connect(this.model.properties.snapshot.change,()=>this.snapshot()),this.connect(this.model.properties.paused.change,()=>this.pause())}pause(){this.model.paused&&(null!=this.timer&&(clearInterval(this.timer),this.timer=null),this.videoEl.pause()),this.set_timeout()}set_timeout(){this.timer&&(clearInterval(this.timer),this.timer=null),this.model.timeout>0&&(this.timer=setInterval(()=>this.snapshot(),this.model.timeout))}snapshot(){this.canvasEl.width=this.videoEl.videoWidth,this.canvasEl.height=this.videoEl.videoHeight;const e=this.canvasEl.getContext("2d");e&&e.drawImage(this.videoEl,0,0,this.canvasEl.width,this.canvasEl.height),this.model.value=this.canvasEl.toDataURL("image/"+this.model.format,.95)}remove(){super.remove(),this.timer&&(clearInterval(this.timer),this.timer=null)}render(){super.render(),this.videoEl||(this.videoEl=document.createElement("video"),this.model.sizing_mode&&"fixed"!==this.model.sizing_mode||(this.model.height&&(this.videoEl.height=this.model.height),this.model.width&&(this.videoEl.width=this.model.width)),this.videoEl.style.objectFit="fill",this.videoEl.style.minWidth="100%",this.videoEl.style.minHeight="100%",this.canvasEl=document.createElement("canvas"),this.el.appendChild(this.videoEl),navigator.mediaDevices.getUserMedia&&navigator.mediaDevices.getUserMedia(this.constraints).then(e=>{this.videoEl.srcObject=e,this.model.paused||this.videoEl.play()}).catch(console.error))}}i.VideoStreamView=a,a.__name__="VideoStreamView";class l extends o.HTMLBox{constructor(e){super(e)}static init_VideoStream(){this.prototype.default_view=a,this.define({format:[s.String,"png"],paused:[s.Boolean,!1],snapshot:[s.Boolean,!1],timeout:[s.Number,0],value:[s.Any]}),this.override({height:240,width:320})}}i.VideoStream=l,l.__name__="VideoStream",l.__module__="panel.models.widgets",l.init_VideoStream()},
"ecfbb965eb": function _(e,o,l){Object.defineProperty(l,"__esModule",{value:!0});var V=e("5b5e56e89a");l.VTKPlot=V.VTKPlot;var t=e("729dd26c71");l.VTKVolumePlot=t.VTKVolumePlot;var K=e("e23461e5d7");l.VTKAxes=K.VTKAxes},
"5b5e56e89a": function _(e,t,n){Object.defineProperty(n,"__esModule",{value:!0});const s=e("tslib").__importStar(e("@bokehjs/core/properties")),i=e("@bokehjs/core/dom"),a=e("c704c63c0a"),o=e("ba07c3d566");class r extends a.AbstractVTKView{constructor(){super(...arguments),this._axes_initialized=!1}connect_signals(){super.connect_signals(),this.connect(this.model.properties.axes.change,()=>{this._delete_axes(),this.model.axes&&this._set_axes(),this._vtk_renwin.getRenderWindow().render()}),this.el.addEventListener("mouseenter",()=>{const e=this._vtk_renwin.getInteractor();this.model.enable_keybindings&&(document.querySelector("body").addEventListener("keypress",e.handleKeyPress),document.querySelector("body").addEventListener("keydown",e.handleKeyDown),document.querySelector("body").addEventListener("keyup",e.handleKeyUp))}),this.el.addEventListener("mouseleave",()=>{const e=this._vtk_renwin.getInteractor();document.querySelector("body").removeEventListener("keypress",e.handleKeyPress),document.querySelector("body").removeEventListener("keydown",e.handleKeyDown),document.querySelector("body").removeEventListener("keyup",e.handleKeyUp)})}render(){super.render(),this._axes=null,this._axes_initialized=!1,this._plot()}after_layout(){this._axes_initialized||(this._render_axes_canvas(),this._axes_initialized=!0)}_render_axes_canvas(){const e=this._vtk_container.getElementsByTagName("canvas");if(1!=e.length)throw Error("Error at initialization of the 3D scene, container should have one and only one canvas");e[0].classList.add("scene3d-canvas");const t=i.canvas({style:{position:"absolute",top:"0",left:"0",width:"100%",height:"100%"}});t.classList.add("axes-canvas"),this._vtk_container.appendChild(t),this._vtk_renwin.setResizeCallback(()=>{const e=this._vtk_container.getBoundingClientRect(),n=Math.floor(e.width*window.devicePixelRatio),s=Math.floor(e.height*window.devicePixelRatio);t.setAttribute("width",n.toFixed()),t.setAttribute("height",s.toFixed())})}_delete_axes(){if(null==this._axes)return;Object.keys(this._axes).forEach(e=>this._vtk_renwin.getRenderer().removeActor(this._axes[e]));const e=this._vtk_renwin.getContainer().getElementsByClassName("axes-canvas")[0],t=e.getContext("2d");t&&t.clearRect(0,0,e.clientWidth*window.devicePixelRatio,e.clientHeight*window.devicePixelRatio),this._axes=null}_set_axes(){if(this.model.axes){const e=this._vtk_renwin.getContainer().getElementsByClassName("axes-canvas")[0],{psActor:t,axesActor:n,gridActor:s}=this.model.axes.create_axes(e);this._axes={psActor:t,axesActor:n,gridActor:s},this._vtk_renwin.getRenderer().addActor(t),this._vtk_renwin.getRenderer().addActor(n),this._vtk_renwin.getRenderer().addActor(s)}}_plot(){if(!this.model.data)return void this._vtk_renwin.getRenderWindow().render();const e=o.vtkns.DataAccessHelper.get("zip",{zipContent:atob(this.model.data),callback:t=>{const n=o.vtkns.HttpSceneLoader.newInstance({renderer:this._vtk_renwin.getRenderer(),dataAccessHelper:e}),s=o.vtk.macro.debounce(()=>{null==this._axes&&this.model.axes&&this._set_axes(),this.model.properties.camera.change.emit()},100);n.setUrl("index.json"),n.onReady(s)}})}}n.VTKPlotView=r,r.__name__="VTKPlotView";class d extends a.AbstractVTKPlot{constructor(e){super(e),this.outline=o.vtkns.OutlineFilter.newInstance();const t=o.vtkns.Mapper.newInstance();t.setInputConnection(this.outline.getOutputPort()),this.outline_actor=o.vtkns.Actor.newInstance(),this.outline_actor.setMapper(t)}static init_VTKPlot(){this.prototype.default_view=r,this.define({data:[s.String],axes:[s.Instance],enable_keybindings:[s.Boolean,!1]})}}n.VTKPlot=d,d.__name__="VTKPlot",d.init_VTKPlot()},
"c704c63c0a": function _(e,t,i){Object.defineProperty(i,"__esModule",{value:!0});const n=e("tslib").__importStar(e("@bokehjs/core/properties")),r=e("@bokehjs/core/dom"),s=e("@bokehjs/core/util/object"),a=e("@bokehjs/models/layouts/html_box"),o=e("ba20932521"),_=e("ba07c3d566");class d extends o.PanelHTMLBoxView{constructor(){super(...arguments),this._setting_camera=!1}connect_signals(){super.connect_signals(),this.connect(this.model.properties.data.change,()=>{this.invalidate_render()}),this.connect(this.model.properties.orientation_widget.change,()=>{this._orientation_widget_visibility(this.model.orientation_widget)}),this.connect(this.model.properties.camera.change,()=>this._set_camera_state())}_orientation_widget_visibility(e){this._orientationWidget.setEnabled(e),e?this._widgetManager.enablePicking():this._widgetManager.disablePicking(),this._orientationWidget.updateMarkerOrientation(),this._vtk_renwin.getRenderWindow().render()}_create_orientation_widget(){const e=_.vtkns.AxesActor.newInstance(),t=_.vtkns.OrientationMarkerWidget.newInstance({actor:e,interactor:this._vtk_renwin.getInteractor()});t.setEnabled(!0),t.setViewportCorner(_.vtkns.OrientationMarkerWidget.Corners.BOTTOM_RIGHT),t.setViewportSize(.15),t.setMinPixelSize(100),t.setMaxPixelSize(300),this._orientationWidget=t;const i=_.vtkns.WidgetManager.newInstance();i.setRenderer(t.getRenderer());const n=_.vtkns.InteractiveOrientationWidget.newInstance();n.placeWidget(e.getBounds()),n.setBounds(e.getBounds()),n.setPlaceFactor(1);const r=i.addWidget(n);this._widgetManager=i,r.onOrientationChange(({direction:e})=>{const t=this._vtk_renwin.getRenderer().getActiveCamera(),i=t.getFocalPoint(),n=t.getPosition(),r=t.getViewUp(),s=Math.sqrt(Math.pow(n[0]-i[0],2)+Math.pow(n[1]-i[1],2)+Math.pow(n[2]-i[2],2));t.setPosition(i[0]+e[0]*s,i[1]+e[1]*s,i[2]+e[2]*s),e[0]&&t.setViewUp(_.majorAxis(r,1,2)),e[1]&&t.setViewUp(_.majorAxis(r,0,2)),e[2]&&t.setViewUp(_.majorAxis(r,0,1)),this._orientationWidget.updateMarkerOrientation(),this._vtk_renwin.getRenderer().resetCameraClippingRange(),this._vtk_renwin.getRenderWindow().render()}),this._orientation_widget_visibility(this.model.orientation_widget)}_get_camera_state(){if(!this._setting_camera){this._setting_camera=!0;const e=s.clone(this._vtk_renwin.getRenderer().getActiveCamera().get());delete e.classHierarchy,delete e.vtkObject,delete e.vtkCamera,delete e.viewPlaneNormal,this.model.camera=e,this._setting_camera=!1}}_set_camera_state(){if(!this._setting_camera){this._setting_camera=!0;try{this.model.camera&&this._vtk_renwin.getRenderer().getActiveCamera().set(this.model.camera)}finally{this._setting_camera=!1}this._orientationWidget.updateMarkerOrientation(),this._vtk_renwin.getRenderer().resetCameraClippingRange(),this._vtk_renwin.getRenderWindow().render()}}render(){super.render(),this._orientationWidget=null,this._vtk_container=r.div(),o.set_size(this._vtk_container,this.model),this.el.appendChild(this._vtk_container),this._vtk_renwin=_.vtkns.FullScreenRenderWindow.newInstance({rootContainer:this.el,container:this._vtk_container}),this._remove_default_key_binding(),this._create_orientation_widget(),this._vtk_renwin.getRenderer().getActiveCamera().onModified(()=>this._get_camera_state()),this._set_camera_state(),this.model.renderer_el=this._vtk_renwin}after_layout(){super.after_layout(),this._vtk_renwin.resize()}_remove_default_key_binding(){const e=this._vtk_renwin.getInteractor();document.querySelector("body").removeEventListener("keypress",e.handleKeyPress),document.querySelector("body").removeEventListener("keydown",e.handleKeyDown),document.querySelector("body").removeEventListener("keyup",e.handleKeyUp)}}i.AbstractVTKView=d,d.__name__="AbstractVTKView";class c extends a.HTMLBox{constructor(e){super(e)}getActors(){return this.renderer_el.getRenderer().getActors()}static init_AbstractVTKPlot(){this.define({orientation_widget:[n.Boolean,!1],camera:[n.Instance]}),this.override({height:300,width:300})}}i.AbstractVTKPlot=c,c.__name__="AbstractVTKPlot",c.__module__="panel.models.vtk",c.init_AbstractVTKPlot()},
"ba07c3d566": function _(e,t,n){Object.defineProperty(n,"__esModule",{value:!0});const r=e("@bokehjs/core/util/serialization"),a=e("@bokehjs/core/util/array");function o(e){const t=Math.min(Math.max(Math.round(e),0),255).toString(16);return 2==t.length?t:"0"+t}function i(e,t,n){return"#"+o(e)+o(t)+o(n)}function s(e){for(var t=new ArrayBuffer(e.length),n=new Uint8Array(t),r=0,a=e.length;r<a;r++)n[r]=e.charCodeAt(r);return t}n.vtk=window.vtk,n.vtkns={},n.vtk&&(n.vtkns.DataArray=n.vtk.Common.Core.vtkDataArray,n.vtkns.ImageData=n.vtk.Common.DataModel.vtkImageData,n.vtkns.OutlineFilter=n.vtk.Filters.General.vtkOutlineFilter,n.vtkns.CubeSource=n.vtk.Filters.Sources.vtkCubeSource,n.vtkns.LineSource=n.vtk.Filters.Sources.vtkLineSource,n.vtkns.PlaneSource=n.vtk.Filters.Sources.vtkPlaneSource,n.vtkns.PointSource=n.vtk.Filters.Sources.vtkPointSource,n.vtkns.OrientationMarkerWidget=n.vtk.Interaction.Widgets.vtkOrientationMarkerWidget,n.vtkns.DataAccessHelper=n.vtk.IO.Core.DataAccessHelper,n.vtkns.HttpSceneLoader=n.vtk.IO.Core.vtkHttpSceneLoader,n.vtkns.ImageSlice=n.vtk.Rendering.Core.vtkImageSlice,n.vtkns.Actor=n.vtk.Rendering.Core.vtkActor,n.vtkns.AxesActor=n.vtk.Rendering.Core.vtkAxesActor,n.vtkns.Mapper=n.vtk.Rendering.Core.vtkMapper,n.vtkns.ImageMapper=n.vtk.Rendering.Core.vtkImageMapper,n.vtkns.SphereMapper=n.vtk.Rendering.Core.vtkSphereMapper,n.vtkns.WidgetManager=n.vtk.Widgets.Core.vtkWidgetManager,n.vtkns.InteractiveOrientationWidget=n.vtk.Widgets.Widgets3D.vtkInteractiveOrientationWidget,n.vtkns.PixelSpaceCallbackMapper=n.vtk.Rendering.Core.vtkPixelSpaceCallbackMapper,n.vtkns.FullScreenRenderWindow=n.vtk.Rendering.Misc.vtkFullScreenRenderWindow,n.vtkns.VolumeController=n.vtk.Interaction.UI.vtkVolumeController,n.vtkns.Volume=n.vtk.Rendering.Core.vtkVolume,n.vtkns.VolumeMapper=n.vtk.Rendering.Core.vtkVolumeMapper,n.vtkns.ColorTransferFunction=n.vtk.Rendering.Core.vtkColorTransferFunction,n.vtkns.PiecewiseFunction=n.vtk.Common.DataModel.vtkPiecewiseFunction,n.vtkns.BoundingBox=n.vtk.Common.DataModel.vtkBoundingBox),n.hexToRGB=function(e){return[parseInt(e.slice(1,3),16)/255,parseInt(e.slice(3,5),16)/255,parseInt(e.slice(5,7),16)/255]},n.rgbToHex=i,n.vtkLutToMapper=function(e){const{scale:t,nodes:r}=e.get("scale","nodes");if(t!==n.vtkns.ColorTransferFunction.Scale.LINEAR)throw"Error transfer function scale not handle";const o=r.map(e=>e.x),s=Math.min(...o),k=Math.max(...o),v=a.linspace(s,k,255),c=[0,0,0];return{low:s,high:k,palette:v.map(t=>(e.getColor(t,c),i(255*c[0],255*c[1],255*c[2])))}},n.data2VTKImageData=function(e){const t=n.vtkns.ImageData.newInstance({spacing:e.spacing});t.setDimensions(e.dims),t.setOrigin(null!=e.origin?e.origin:e.dims.map(e=>e/2));const a=n.vtkns.DataArray.newInstance({name:"scalars",numberOfComponents:1,values:new r.ARRAY_TYPES[e.dtype](s(atob(e.buffer)))});return t.getPointData().setScalars(a),t},n.majorAxis=function(e,t,n){const r=[0,0,0],a=Math.abs(e[t])>Math.abs(e[n])?t:n,o=e[a]>0?1:-1;return r[a]=o,r},n.cartesian_product=function(...e){return e.reduce((e,t)=>e.flatMap(e=>t.map(t=>[].concat(e,t))))}},
"729dd26c71": function _(e,t,i){Object.defineProperty(i,"__esModule",{value:!0});const s=e("tslib").__importStar(e("@bokehjs/core/properties")),r=e("c704c63c0a"),n=e("ba07c3d566");class o extends r.AbstractVTKView{connect_signals(){super.connect_signals(),this.connect(this.model.properties.colormap.change,()=>{this.colormap_slector.value=this.model.colormap;const e=new Event("change");this.colormap_slector.dispatchEvent(e)}),this.connect(this.model.properties.shadow.change,()=>{this.shadow_selector.value=this.model.shadow?"1":"0";const e=new Event("change");this.shadow_selector.dispatchEvent(e)}),this.connect(this.model.properties.sampling.change,()=>{this.sampling_slider.value=this.model.sampling.toFixed(2);const e=new Event("input");this.sampling_slider.dispatchEvent(e)}),this.connect(this.model.properties.edge_gradient.change,()=>{this.edge_gradient_slider.value=this.model.edge_gradient.toFixed(2);const e=new Event("input");this.edge_gradient_slider.dispatchEvent(e)}),this.connect(this.model.properties.rescale.change,()=>{this._controllerWidget.setRescaleColorMap(this.model.rescale),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.ambient.change,()=>{this.volume.getProperty().setAmbient(this.model.ambient),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.diffuse.change,()=>{this.volume.getProperty().setDiffuse(this.model.diffuse),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.specular.change,()=>{this.volume.getProperty().setSpecular(this.model.specular),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.specular_power.change,()=>{this.volume.getProperty().setSpecularPower(this.model.specular_power),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.display_volume.change,()=>{this._set_volume_visibility(this.model.display_volume),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.display_slices.change,()=>{this._set_slices_visibility(this.model.display_slices),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_i.change,()=>{this.image_actor_i.getMapper().setISlice(this.model.slice_i),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_j.change,()=>{this.image_actor_j.getMapper().setJSlice(this.model.slice_j),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_k.change,()=>{this.image_actor_k.getMapper().setKSlice(this.model.slice_k),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.render_background.change,()=>{this._vtk_renwin.getRenderer().setBackground(...n.hexToRGB(this.model.render_background)),this._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.interpolation.change,()=>{this._set_interpolation(this.model.interpolation),this._vtk_renwin.getRenderWindow().render()})}get volume(){return this._controllerWidget.getActor()}get image_actor_i(){return this._vtk_renwin.getRenderer().getActors()[0]}get image_actor_j(){return this._vtk_renwin.getRenderer().getActors()[1]}get image_actor_k(){return this._vtk_renwin.getRenderer().getActors()[2]}get shadow_selector(){return this.el.querySelector(".js-shadow")}get edge_gradient_slider(){return this.el.querySelector(".js-edge")}get sampling_slider(){return this.el.querySelector(".js-spacing")}get colormap_slector(){return this.el.querySelector(".js-color-preset")}_set_interpolation(e){"fast_linear"==e?(this.volume.getProperty().setInterpolationTypeToFastLinear(),this.image_actor_i.getProperty().setInterpolationTypeToLinear()):"linear"==e?(this.volume.getProperty().setInterpolationTypeToLinear(),this.image_actor_i.getProperty().setInterpolationTypeToLinear()):(this.volume.getProperty().setInterpolationTypeToNearest(),this.image_actor_i.getProperty().setInterpolationTypeToNearest())}render(){super.render(),this._controllerWidget=n.vtkns.VolumeController.newInstance({size:[400,150],rescaleColorMap:this.model.rescale}),this._vtk_image_data=n.data2VTKImageData(this.model.data),this._controllerWidget.setContainer(this.el),this._vtk_renwin.getRenderWindow().getInteractor(),this._vtk_renwin.getRenderWindow().getInteractor().setDesiredUpdateRate(45),this._plot_volume(),this._connect_controls(),this._plot_slices(),this._set_volume_visibility(this.model.display_volume),this._set_slices_visibility(this.model.display_slices),this._vtk_renwin.getRenderer().setBackground(...n.hexToRGB(this.model.render_background)),this._set_interpolation(this.model.interpolation),this._vtk_renwin.getRenderer().resetCamera()}_connect_controls(){this.colormap_slector.addEventListener("change",()=>{this.model.colormap=this.colormap_slector.value}),this.model.colormap?this.model.properties.colormap.change.emit():this.model.colormap=this.colormap_slector.value,this.shadow_selector.addEventListener("change",()=>{this.model.shadow=!!Number(this.shadow_selector.value)}),(this.model.shadow=!!Number(this.shadow_selector.value))&&this.model.properties.shadow.change.emit(),this.sampling_slider.addEventListener("input",()=>{const e=Number(this.sampling_slider.value);Math.abs(this.model.sampling-e)>=.005&&(this.model.sampling=e)}),Math.abs(this.model.sampling-Number(this.shadow_selector.value))>=.005&&this.model.properties.sampling.change.emit(),this.edge_gradient_slider.addEventListener("input",()=>{const e=Number(this.edge_gradient_slider.value);Math.abs(this.model.edge_gradient-e)>=.005&&(this.model.edge_gradient=e)}),Math.abs(this.model.edge_gradient-Number(this.edge_gradient_slider.value))>=.005&&this.model.properties.edge_gradient.change.emit()}_plot_volume(){const e=this._vtk_image_data,t=n.vtkns.Volume.newInstance(),i=n.vtkns.VolumeMapper.newInstance();t.setMapper(i),i.setInputData(e);const s=(e.getPointData().getScalars()||e.getPointData().getArrays()[0]).getRange(),r=n.vtkns.ColorTransferFunction.newInstance();r.onModified(()=>this.model.mapper=n.vtkLutToMapper(r));const o=n.vtkns.PiecewiseFunction.newInstance(),a=.7*Math.sqrt(e.getSpacing().map(e=>e*e).reduce((e,t)=>e+t,0));i.setSampleDistance(a),t.getProperty().setRGBTransferFunction(0,r),t.getProperty().setScalarOpacity(0,o),t.getProperty().setInterpolationTypeToFastLinear(),t.getProperty().setScalarOpacityUnitDistance(0,n.vtkns.BoundingBox.getDiagonalLength(e.getBounds())/Math.max(...e.getDimensions())),t.getProperty().setGradientOpacityMinimumValue(0,0),t.getProperty().setGradientOpacityMaximumValue(0,.05*(s[1]-s[0])),t.getProperty().setShade(this.model.shadow),t.getProperty().setUseGradientOpacity(0,!0),t.getProperty().setGradientOpacityMinimumOpacity(0,0),t.getProperty().setGradientOpacityMaximumOpacity(0,1),t.getProperty().setAmbient(this.model.ambient),t.getProperty().setDiffuse(this.model.diffuse),t.getProperty().setSpecular(this.model.specular),t.getProperty().setSpecularPower(this.model.specular_power),this._vtk_renwin.getRenderer().addVolume(t),this._controllerWidget.setupContent(this._vtk_renwin.getRenderWindow(),t,!0)}_plot_slices(){const e=this._vtk_image_data,t=n.vtkns.ImageSlice.newInstance(),i=n.vtkns.ImageSlice.newInstance(),s=n.vtkns.ImageSlice.newInstance(),r=n.vtkns.ImageMapper.newInstance(),o=n.vtkns.ImageMapper.newInstance(),a=n.vtkns.ImageMapper.newInstance();r.setInputData(e),r.setISlice(this.model.slice_i),t.setMapper(r),o.setInputData(e),o.setJSlice(this.model.slice_j),i.setMapper(o),a.setInputData(e),a.setKSlice(this.model.slice_k),s.setMapper(a);const l=n.vtkns.PiecewiseFunction.newInstance();l.removeAllPoints(),l.addPoint(0,1);const c=this.volume.getProperty().getRGBTransferFunction(0),d=t.getProperty();i.setProperty(d),s.setProperty(d),d.setRGBTransferFunction(c),d.setScalarOpacity(l);const h=this._vtk_renwin.getRenderer();h.addActor(t),h.addActor(i),h.addActor(s)}_set_volume_visibility(e){this.volume.setVisibility(e)}_set_slices_visibility(e){this._vtk_renwin.getRenderer().getActors().map(t=>t.setVisibility(e))}}i.VTKVolumePlotView=o,o.__name__="VTKVolumePlotView";class a extends r.AbstractVTKPlot{constructor(e){super(e)}static init_VTKVolumePlot(){this.prototype.default_view=o,this.define({data:[s.Instance],shadow:[s.Boolean,!0],sampling:[s.Number,.4],edge_gradient:[s.Number,.2],colormap:[s.String],rescale:[s.Boolean,!1],ambient:[s.Number,.2],diffuse:[s.Number,.7],specular:[s.Number,.3],specular_power:[s.Number,8],slice_i:[s.Int,0],slice_j:[s.Int,0],slice_k:[s.Int,0],display_volume:[s.Boolean,!0],display_slices:[s.Boolean,!1],render_background:[s.String,"#52576e"],interpolation:[s.Any,"fast_linear"],mapper:[s.Instance]})}}i.VTKVolumePlot=a,a.__name__="VTKVolumePlot",a.init_VTKVolumePlot()},
"e23461e5d7": function _(t,s,i){Object.defineProperty(i,"__esModule",{value:!0});const e=t("tslib"),n=t("2f3fd5db07"),a=t("@bokehjs/model"),c=e.__importStar(t("@bokehjs/core/properties")),r=t("ba07c3d566");class h extends a.Model{constructor(t){super(t)}static init_VTKAxes(){this.define({origin:[c.Array],xticker:[c.Instance],yticker:[c.Instance],zticker:[c.Instance],digits:[c.Number,1],show_grid:[c.Boolean,!0],grid_opacity:[c.Number,.1],axes_opacity:[c.Number,1],fontsize:[c.Number,12]})}get xticks(){return this.xticker.ticks}get yticks(){return this.yticker.ticks}get zticks(){return this.zticker.ticks}get xlabels(){return this.xticker.labels?this.xticker.labels:this.xticks.map(t=>t.toFixed(this.digits))}get ylabels(){return this.yticker.labels?this.yticker.labels:this.yticks.map(t=>t.toFixed(this.digits))}get zlabels(){return this.zticker.labels?this.zticker.labels:this.zticks.map(t=>t.toFixed(this.digits))}_make_grid_lines(t,s,i){const e=[];for(let n=0;n<t-1;n++)for(let t=0;t<s-1;t++){const a=n*s+t+i,c=[5,a,n*s+t+1+i,(n+1)*s+t+1+i,(n+1)*s+t+i,a];e.push(c)}return e}_create_grid_axes(){const t=[];t.push(r.cartesian_product(this.xticks,this.yticks,[this.origin[2]])),t.push(r.cartesian_product([this.origin[0]],this.yticks,this.zticks)),t.push(r.cartesian_product(this.xticks,[this.origin[1]],this.zticks));const s=[];let i=0;s.push(this._make_grid_lines(this.xticks.length,this.yticks.length,i)),i+=this.xticks.length*this.yticks.length,s.push(this._make_grid_lines(this.yticks.length,this.zticks.length,i)),i+=this.yticks.length*this.zticks.length,s.push(this._make_grid_lines(this.xticks.length,this.zticks.length,i));const e=r.vtk({vtkClass:"vtkPolyData",points:{vtkClass:"vtkPoints",dataType:"Float32Array",numberOfComponents:3,values:t.flat(2)},lines:{vtkClass:"vtkCellArray",dataType:"Uint32Array",values:s.flat(2)}}),n=r.vtkns.Mapper.newInstance(),a=r.vtkns.Actor.newInstance();return n.setInputData(e),a.setMapper(n),a.getProperty().setOpacity(this.grid_opacity),a.setVisibility(this.show_grid),a}create_axes(t){const s=[this.xticks,this.yticks,this.zticks].map((t,s)=>{let i=null;switch(s){case 0:i=r.cartesian_product(t,[this.origin[1]],[this.origin[2]]);break;case 1:i=r.cartesian_product([this.origin[0]],t,[this.origin[2]]);break;case 2:i=r.cartesian_product([this.origin[0]],[this.origin[1]],t)}return i}).flat(2),i=r.vtk({vtkClass:"vtkPolyData",points:{vtkClass:"vtkPoints",dataType:"Float32Array",numberOfComponents:3,values:s},lines:{vtkClass:"vtkCellArray",dataType:"Uint32Array",values:[2,0,this.xticks.length-1,2,this.xticks.length,this.xticks.length+this.yticks.length-1,2,this.xticks.length+this.yticks.length,this.xticks.length+this.yticks.length+this.zticks.length-1]}}),e=r.vtkns.PixelSpaceCallbackMapper.newInstance();e.setInputData(i),e.setUseZValues(!0),e.setCallback((s,i,a)=>{const c=t.getContext("2d");if(c){const r={height:t.clientHeight*window.devicePixelRatio,width:t.clientWidth*window.devicePixelRatio},h=e.getInputData().getPoints(),l=i.getViewMatrix();n.mat4.transpose(l,l);const o=i.getProjectionMatrix(a,-1,1);n.mat4.transpose(o,o),c.clearRect(0,0,r.width,r.height),s.forEach((t,s)=>{const i=h.getPoint(s),e=n.vec3.fromValues(i[0],i[1],i[2]);if(n.vec3.transformMat4(e,e,l),e[2]+=.05,n.vec3.transformMat4(e,e,o),e[2]-.001<t[3]){let i;c.font="30px serif",c.textAlign="center",c.textBaseline="alphabetic",c.fillText(".",t[0],r.height-t[1]+2),c.font=`${this.fontsize*window.devicePixelRatio}px serif`,c.textAlign="right",c.textBaseline="top",i=s<this.xticks.length?this.xlabels[s]:s>=this.xticks.length&&s<this.xticks.length+this.yticks.length?this.ylabels[s-this.xticks.length]:this.zlabels[s-(this.xticks.length+this.yticks.length)],c.fillText(`${i}`,t[0],r.height-t[1])}})}});const a=r.vtkns.Actor.newInstance();a.setMapper(e);const c=r.vtkns.Mapper.newInstance();c.setInputData(i);const h=r.vtkns.Actor.newInstance();return h.setMapper(c),h.getProperty().setOpacity(this.axes_opacity),{psActor:a,axesActor:h,gridActor:this._create_grid_axes()}}}i.VTKAxes=h,h.__name__="VTKAxes",h.__module__="panel.models.vtk",h.init_VTKAxes()},
"2f3fd5db07": function _(t,c,a){Object.defineProperty(a,"__esModule",{value:!0});const o=t("tslib"),r=o.__importStar(t("68ca94c15c"));a.glMatrix=r;const _=o.__importStar(t("7c0b8e6048"));a.mat2=_;const e=o.__importStar(t("dc03f0a621"));a.mat2d=e;const i=o.__importStar(t("0285c50a7e"));a.mat3=i;const m=o.__importStar(t("a427635f32"));a.mat4=m;const n=o.__importStar(t("eb06fc032a"));a.quat=n;const s=o.__importStar(t("277615c682"));a.quat2=s;const p=o.__importStar(t("c56d9ff837"));a.vec2=p;const S=o.__importStar(t("2c5eb22089"));a.vec3=S;const f=o.__importStar(t("c1aa33d719"));a.vec4=f},
"68ca94c15c": function _(t,a,r){Object.defineProperty(r,"__esModule",{value:!0}),r.EPSILON=1e-6,r.ARRAY_TYPE="undefined"!=typeof Float32Array?Float32Array:Array,r.RANDOM=Math.random,r.setMatrixArrayType=function(t){r.ARRAY_TYPE=t};var n=Math.PI/180;r.toRadian=function(t){return t*n},r.equals=function(t,a){return Math.abs(t-a)<=r.EPSILON*Math.max(1,Math.abs(t),Math.abs(a))},Math.hypot||(Math.hypot=function(){for(var t=0,a=arguments.length;a--;)t+=arguments[a]*arguments[a];return Math.sqrt(t)})},
"7c0b8e6048": function _(t,n,r){Object.defineProperty(r,"__esModule",{value:!0});const a=t("tslib").__importStar(t("68ca94c15c"));function u(t,n,r){var a=n[0],u=n[1],e=n[2],o=n[3],c=r[0],i=r[1],f=r[2],s=r[3];return t[0]=a*c+e*i,t[1]=u*c+o*i,t[2]=a*f+e*s,t[3]=u*f+o*s,t}function e(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t}r.create=function(){var t=new a.ARRAY_TYPE(4);return a.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0),t[0]=1,t[3]=1,t},r.clone=function(t){var n=new a.ARRAY_TYPE(4);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t},r.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},r.fromValues=function(t,n,r,u){var e=new a.ARRAY_TYPE(4);return e[0]=t,e[1]=n,e[2]=r,e[3]=u,e},r.set=function(t,n,r,a,u){return t[0]=n,t[1]=r,t[2]=a,t[3]=u,t},r.transpose=function(t,n){if(t===n){var r=n[1];t[1]=n[2],t[2]=r}else t[0]=n[0],t[1]=n[2],t[2]=n[1],t[3]=n[3];return t},r.invert=function(t,n){var r=n[0],a=n[1],u=n[2],e=n[3],o=r*e-u*a;return o?(o=1/o,t[0]=e*o,t[1]=-a*o,t[2]=-u*o,t[3]=r*o,t):null},r.adjoint=function(t,n){var r=n[0];return t[0]=n[3],t[1]=-n[1],t[2]=-n[2],t[3]=r,t},r.determinant=function(t){return t[0]*t[3]-t[2]*t[1]},r.multiply=u,r.rotate=function(t,n,r){var a=n[0],u=n[1],e=n[2],o=n[3],c=Math.sin(r),i=Math.cos(r);return t[0]=a*i+e*c,t[1]=u*i+o*c,t[2]=a*-c+e*i,t[3]=u*-c+o*i,t},r.scale=function(t,n,r){var a=n[0],u=n[1],e=n[2],o=n[3],c=r[0],i=r[1];return t[0]=a*c,t[1]=u*c,t[2]=e*i,t[3]=o*i,t},r.fromRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=r,t[2]=-r,t[3]=a,t},r.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=n[1],t},r.str=function(t){return"mat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},r.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3])},r.LDU=function(t,n,r,a){return t[2]=a[2]/a[0],r[0]=a[0],r[1]=a[1],r[3]=a[3]-t[2]*r[1],[t,n,r]},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t},r.subtract=e,r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]},r.equals=function(t,n){var r=t[0],u=t[1],e=t[2],o=t[3],c=n[0],i=n[1],f=n[2],s=n[3];return Math.abs(r-c)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(c))&&Math.abs(u-i)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(i))&&Math.abs(e-f)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(f))&&Math.abs(o-s)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(s))},r.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t},r.multiplyScalarAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t},r.mul=u,r.sub=e},
"dc03f0a621": function _(t,n,a){Object.defineProperty(a,"__esModule",{value:!0});const r=t("tslib").__importStar(t("68ca94c15c"));function u(t,n,a){var r=n[0],u=n[1],e=n[2],o=n[3],c=n[4],i=n[5],s=a[0],f=a[1],h=a[2],M=a[3],b=a[4],l=a[5];return t[0]=r*s+e*f,t[1]=u*s+o*f,t[2]=r*h+e*M,t[3]=u*h+o*M,t[4]=r*b+e*l+c,t[5]=u*b+o*l+i,t}function e(t,n,a){return t[0]=n[0]-a[0],t[1]=n[1]-a[1],t[2]=n[2]-a[2],t[3]=n[3]-a[3],t[4]=n[4]-a[4],t[5]=n[5]-a[5],t}a.create=function(){var t=new r.ARRAY_TYPE(6);return r.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[4]=0,t[5]=0),t[0]=1,t[3]=1,t},a.clone=function(t){var n=new r.ARRAY_TYPE(6);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n[4]=t[4],n[5]=t[5],n},a.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t[4]=n[4],t[5]=n[5],t},a.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},a.fromValues=function(t,n,a,u,e,o){var c=new r.ARRAY_TYPE(6);return c[0]=t,c[1]=n,c[2]=a,c[3]=u,c[4]=e,c[5]=o,c},a.set=function(t,n,a,r,u,e,o){return t[0]=n,t[1]=a,t[2]=r,t[3]=u,t[4]=e,t[5]=o,t},a.invert=function(t,n){var a=n[0],r=n[1],u=n[2],e=n[3],o=n[4],c=n[5],i=a*e-r*u;return i?(i=1/i,t[0]=e*i,t[1]=-r*i,t[2]=-u*i,t[3]=a*i,t[4]=(u*c-e*o)*i,t[5]=(r*o-a*c)*i,t):null},a.determinant=function(t){return t[0]*t[3]-t[1]*t[2]},a.multiply=u,a.rotate=function(t,n,a){var r=n[0],u=n[1],e=n[2],o=n[3],c=n[4],i=n[5],s=Math.sin(a),f=Math.cos(a);return t[0]=r*f+e*s,t[1]=u*f+o*s,t[2]=r*-s+e*f,t[3]=u*-s+o*f,t[4]=c,t[5]=i,t},a.scale=function(t,n,a){var r=n[0],u=n[1],e=n[2],o=n[3],c=n[4],i=n[5],s=a[0],f=a[1];return t[0]=r*s,t[1]=u*s,t[2]=e*f,t[3]=o*f,t[4]=c,t[5]=i,t},a.translate=function(t,n,a){var r=n[0],u=n[1],e=n[2],o=n[3],c=n[4],i=n[5],s=a[0],f=a[1];return t[0]=r,t[1]=u,t[2]=e,t[3]=o,t[4]=r*s+e*f+c,t[5]=u*s+o*f+i,t},a.fromRotation=function(t,n){var a=Math.sin(n),r=Math.cos(n);return t[0]=r,t[1]=a,t[2]=-a,t[3]=r,t[4]=0,t[5]=0,t},a.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=n[1],t[4]=0,t[5]=0,t},a.fromTranslation=function(t,n){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=n[0],t[5]=n[1],t},a.str=function(t){return"mat2d("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+")"},a.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],1)},a.add=function(t,n,a){return t[0]=n[0]+a[0],t[1]=n[1]+a[1],t[2]=n[2]+a[2],t[3]=n[3]+a[3],t[4]=n[4]+a[4],t[5]=n[5]+a[5],t},a.subtract=e,a.multiplyScalar=function(t,n,a){return t[0]=n[0]*a,t[1]=n[1]*a,t[2]=n[2]*a,t[3]=n[3]*a,t[4]=n[4]*a,t[5]=n[5]*a,t},a.multiplyScalarAndAdd=function(t,n,a,r){return t[0]=n[0]+a[0]*r,t[1]=n[1]+a[1]*r,t[2]=n[2]+a[2]*r,t[3]=n[3]+a[3]*r,t[4]=n[4]+a[4]*r,t[5]=n[5]+a[5]*r,t},a.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]&&t[4]===n[4]&&t[5]===n[5]},a.equals=function(t,n){var a=t[0],u=t[1],e=t[2],o=t[3],c=t[4],i=t[5],s=n[0],f=n[1],h=n[2],M=n[3],b=n[4],l=n[5];return Math.abs(a-s)<=r.EPSILON*Math.max(1,Math.abs(a),Math.abs(s))&&Math.abs(u-f)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(f))&&Math.abs(e-h)<=r.EPSILON*Math.max(1,Math.abs(e),Math.abs(h))&&Math.abs(o-M)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(M))&&Math.abs(c-b)<=r.EPSILON*Math.max(1,Math.abs(c),Math.abs(b))&&Math.abs(i-l)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))},a.mul=u,a.sub=e},
"0285c50a7e": function _(t,a,n){Object.defineProperty(n,"__esModule",{value:!0});const r=t("tslib").__importStar(t("68ca94c15c"));function u(t,a,n){var r=a[0],u=a[1],o=a[2],e=a[3],i=a[4],c=a[5],s=a[6],M=a[7],h=a[8],f=n[0],b=n[1],l=n[2],m=n[3],v=n[4],E=n[5],P=n[6],S=n[7],d=n[8];return t[0]=f*r+b*e+l*s,t[1]=f*u+b*i+l*M,t[2]=f*o+b*c+l*h,t[3]=m*r+v*e+E*s,t[4]=m*u+v*i+E*M,t[5]=m*o+v*c+E*h,t[6]=P*r+S*e+d*s,t[7]=P*u+S*i+d*M,t[8]=P*o+S*c+d*h,t}function o(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t[3]=a[3]-n[3],t[4]=a[4]-n[4],t[5]=a[5]-n[5],t[6]=a[6]-n[6],t[7]=a[7]-n[7],t[8]=a[8]-n[8],t}n.create=function(){var t=new r.ARRAY_TYPE(9);return r.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[5]=0,t[6]=0,t[7]=0),t[0]=1,t[4]=1,t[8]=1,t},n.fromMat4=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[4],t[4]=a[5],t[5]=a[6],t[6]=a[8],t[7]=a[9],t[8]=a[10],t},n.clone=function(t){var a=new r.ARRAY_TYPE(9);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a[8]=t[8],a},n.copy=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t},n.fromValues=function(t,a,n,u,o,e,i,c,s){var M=new r.ARRAY_TYPE(9);return M[0]=t,M[1]=a,M[2]=n,M[3]=u,M[4]=o,M[5]=e,M[6]=i,M[7]=c,M[8]=s,M},n.set=function(t,a,n,r,u,o,e,i,c,s){return t[0]=a,t[1]=n,t[2]=r,t[3]=u,t[4]=o,t[5]=e,t[6]=i,t[7]=c,t[8]=s,t},n.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},n.transpose=function(t,a){if(t===a){var n=a[1],r=a[2],u=a[5];t[1]=a[3],t[2]=a[6],t[3]=n,t[5]=a[7],t[6]=r,t[7]=u}else t[0]=a[0],t[1]=a[3],t[2]=a[6],t[3]=a[1],t[4]=a[4],t[5]=a[7],t[6]=a[2],t[7]=a[5],t[8]=a[8];return t},n.invert=function(t,a){var n=a[0],r=a[1],u=a[2],o=a[3],e=a[4],i=a[5],c=a[6],s=a[7],M=a[8],h=M*e-i*s,f=-M*o+i*c,b=s*o-e*c,l=n*h+r*f+u*b;return l?(l=1/l,t[0]=h*l,t[1]=(-M*r+u*s)*l,t[2]=(i*r-u*e)*l,t[3]=f*l,t[4]=(M*n-u*c)*l,t[5]=(-i*n+u*o)*l,t[6]=b*l,t[7]=(-s*n+r*c)*l,t[8]=(e*n-r*o)*l,t):null},n.adjoint=function(t,a){var n=a[0],r=a[1],u=a[2],o=a[3],e=a[4],i=a[5],c=a[6],s=a[7],M=a[8];return t[0]=e*M-i*s,t[1]=u*s-r*M,t[2]=r*i-u*e,t[3]=i*c-o*M,t[4]=n*M-u*c,t[5]=u*o-n*i,t[6]=o*s-e*c,t[7]=r*c-n*s,t[8]=n*e-r*o,t},n.determinant=function(t){var a=t[0],n=t[1],r=t[2],u=t[3],o=t[4],e=t[5],i=t[6],c=t[7],s=t[8];return a*(s*o-e*c)+n*(-s*u+e*i)+r*(c*u-o*i)},n.multiply=u,n.translate=function(t,a,n){var r=a[0],u=a[1],o=a[2],e=a[3],i=a[4],c=a[5],s=a[6],M=a[7],h=a[8],f=n[0],b=n[1];return t[0]=r,t[1]=u,t[2]=o,t[3]=e,t[4]=i,t[5]=c,t[6]=f*r+b*e+s,t[7]=f*u+b*i+M,t[8]=f*o+b*c+h,t},n.rotate=function(t,a,n){var r=a[0],u=a[1],o=a[2],e=a[3],i=a[4],c=a[5],s=a[6],M=a[7],h=a[8],f=Math.sin(n),b=Math.cos(n);return t[0]=b*r+f*e,t[1]=b*u+f*i,t[2]=b*o+f*c,t[3]=b*e-f*r,t[4]=b*i-f*u,t[5]=b*c-f*o,t[6]=s,t[7]=M,t[8]=h,t},n.scale=function(t,a,n){var r=n[0],u=n[1];return t[0]=r*a[0],t[1]=r*a[1],t[2]=r*a[2],t[3]=u*a[3],t[4]=u*a[4],t[5]=u*a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t},n.fromTranslation=function(t,a){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=a[0],t[7]=a[1],t[8]=1,t},n.fromRotation=function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=n,t[2]=0,t[3]=-n,t[4]=r,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},n.fromScaling=function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=0,t[4]=a[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},n.fromMat2d=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=0,t[3]=a[2],t[4]=a[3],t[5]=0,t[6]=a[4],t[7]=a[5],t[8]=1,t},n.fromQuat=function(t,a){var n=a[0],r=a[1],u=a[2],o=a[3],e=n+n,i=r+r,c=u+u,s=n*e,M=r*e,h=r*i,f=u*e,b=u*i,l=u*c,m=o*e,v=o*i,E=o*c;return t[0]=1-h-l,t[3]=M-E,t[6]=f+v,t[1]=M+E,t[4]=1-s-l,t[7]=b-m,t[2]=f-v,t[5]=b+m,t[8]=1-s-h,t},n.normalFromMat4=function(t,a){var n=a[0],r=a[1],u=a[2],o=a[3],e=a[4],i=a[5],c=a[6],s=a[7],M=a[8],h=a[9],f=a[10],b=a[11],l=a[12],m=a[13],v=a[14],E=a[15],P=n*i-r*e,S=n*c-u*e,d=n*s-o*e,A=r*c-u*i,x=r*s-o*i,O=u*s-o*c,p=M*m-h*l,I=M*v-f*l,L=M*E-b*l,N=h*v-f*m,R=h*E-b*m,_=f*E-b*v,y=P*_-S*R+d*N+A*L-x*I+O*p;return y?(y=1/y,t[0]=(i*_-c*R+s*N)*y,t[1]=(c*L-e*_-s*I)*y,t[2]=(e*R-i*L+s*p)*y,t[3]=(u*R-r*_-o*N)*y,t[4]=(n*_-u*L+o*I)*y,t[5]=(r*L-n*R-o*p)*y,t[6]=(m*O-v*x+E*A)*y,t[7]=(v*d-l*O-E*S)*y,t[8]=(l*x-m*d+E*P)*y,t):null},n.projection=function(t,a,n){return t[0]=2/a,t[1]=0,t[2]=0,t[3]=0,t[4]=-2/n,t[5]=0,t[6]=-1,t[7]=1,t[8]=1,t},n.str=function(t){return"mat3("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+")"},n.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8])},n.add=function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t[4]=a[4]+n[4],t[5]=a[5]+n[5],t[6]=a[6]+n[6],t[7]=a[7]+n[7],t[8]=a[8]+n[8],t},n.subtract=o,n.multiplyScalar=function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*n,t[5]=a[5]*n,t[6]=a[6]*n,t[7]=a[7]*n,t[8]=a[8]*n,t},n.multiplyScalarAndAdd=function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t[3]=a[3]+n[3]*r,t[4]=a[4]+n[4]*r,t[5]=a[5]+n[5]*r,t[6]=a[6]+n[6]*r,t[7]=a[7]+n[7]*r,t[8]=a[8]+n[8]*r,t},n.exactEquals=function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]&&t[8]===a[8]},n.equals=function(t,a){var n=t[0],u=t[1],o=t[2],e=t[3],i=t[4],c=t[5],s=t[6],M=t[7],h=t[8],f=a[0],b=a[1],l=a[2],m=a[3],v=a[4],E=a[5],P=a[6],S=a[7],d=a[8];return Math.abs(n-f)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(f))&&Math.abs(u-b)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(b))&&Math.abs(o-l)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(l))&&Math.abs(e-m)<=r.EPSILON*Math.max(1,Math.abs(e),Math.abs(m))&&Math.abs(i-v)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(v))&&Math.abs(c-E)<=r.EPSILON*Math.max(1,Math.abs(c),Math.abs(E))&&Math.abs(s-P)<=r.EPSILON*Math.max(1,Math.abs(s),Math.abs(P))&&Math.abs(M-S)<=r.EPSILON*Math.max(1,Math.abs(M),Math.abs(S))&&Math.abs(h-d)<=r.EPSILON*Math.max(1,Math.abs(h),Math.abs(d))},n.mul=u,n.sub=o},
"a427635f32": function _(t,a,n){Object.defineProperty(n,"__esModule",{value:!0});const r=t("tslib").__importStar(t("68ca94c15c"));function h(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}function o(t,a,n){var r=a[0],h=a[1],o=a[2],u=a[3],M=a[4],e=a[5],s=a[6],i=a[7],c=a[8],f=a[9],b=a[10],l=a[11],v=a[12],m=a[13],P=a[14],E=a[15],S=n[0],I=n[1],O=n[2],p=n[3];return t[0]=S*r+I*M+O*c+p*v,t[1]=S*h+I*e+O*f+p*m,t[2]=S*o+I*s+O*b+p*P,t[3]=S*u+I*i+O*l+p*E,S=n[4],I=n[5],O=n[6],p=n[7],t[4]=S*r+I*M+O*c+p*v,t[5]=S*h+I*e+O*f+p*m,t[6]=S*o+I*s+O*b+p*P,t[7]=S*u+I*i+O*l+p*E,S=n[8],I=n[9],O=n[10],p=n[11],t[8]=S*r+I*M+O*c+p*v,t[9]=S*h+I*e+O*f+p*m,t[10]=S*o+I*s+O*b+p*P,t[11]=S*u+I*i+O*l+p*E,S=n[12],I=n[13],O=n[14],p=n[15],t[12]=S*r+I*M+O*c+p*v,t[13]=S*h+I*e+O*f+p*m,t[14]=S*o+I*s+O*b+p*P,t[15]=S*u+I*i+O*l+p*E,t}function u(t,a,n){var r=a[0],h=a[1],o=a[2],u=a[3],M=r+r,e=h+h,s=o+o,i=r*M,c=r*e,f=r*s,b=h*e,l=h*s,v=o*s,m=u*M,P=u*e,E=u*s;return t[0]=1-(b+v),t[1]=c+E,t[2]=f-P,t[3]=0,t[4]=c-E,t[5]=1-(i+v),t[6]=l+m,t[7]=0,t[8]=f+P,t[9]=l-m,t[10]=1-(i+b),t[11]=0,t[12]=n[0],t[13]=n[1],t[14]=n[2],t[15]=1,t}function M(t,a){var n=a[0],r=a[1],h=a[2],o=a[4],u=a[5],M=a[6],e=a[8],s=a[9],i=a[10];return t[0]=Math.hypot(n,r,h),t[1]=Math.hypot(o,u,M),t[2]=Math.hypot(e,s,i),t}function e(t,a,n){return t[0]=a[0]-n[0],t[1]=a[1]-n[1],t[2]=a[2]-n[2],t[3]=a[3]-n[3],t[4]=a[4]-n[4],t[5]=a[5]-n[5],t[6]=a[6]-n[6],t[7]=a[7]-n[7],t[8]=a[8]-n[8],t[9]=a[9]-n[9],t[10]=a[10]-n[10],t[11]=a[11]-n[11],t[12]=a[12]-n[12],t[13]=a[13]-n[13],t[14]=a[14]-n[14],t[15]=a[15]-n[15],t}n.create=function(){var t=new r.ARRAY_TYPE(16);return r.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0),t[0]=1,t[5]=1,t[10]=1,t[15]=1,t},n.clone=function(t){var a=new r.ARRAY_TYPE(16);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a[8]=t[8],a[9]=t[9],a[10]=t[10],a[11]=t[11],a[12]=t[12],a[13]=t[13],a[14]=t[14],a[15]=t[15],a},n.copy=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t[9]=a[9],t[10]=a[10],t[11]=a[11],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15],t},n.fromValues=function(t,a,n,h,o,u,M,e,s,i,c,f,b,l,v,m){var P=new r.ARRAY_TYPE(16);return P[0]=t,P[1]=a,P[2]=n,P[3]=h,P[4]=o,P[5]=u,P[6]=M,P[7]=e,P[8]=s,P[9]=i,P[10]=c,P[11]=f,P[12]=b,P[13]=l,P[14]=v,P[15]=m,P},n.set=function(t,a,n,r,h,o,u,M,e,s,i,c,f,b,l,v,m){return t[0]=a,t[1]=n,t[2]=r,t[3]=h,t[4]=o,t[5]=u,t[6]=M,t[7]=e,t[8]=s,t[9]=i,t[10]=c,t[11]=f,t[12]=b,t[13]=l,t[14]=v,t[15]=m,t},n.identity=h,n.transpose=function(t,a){if(t===a){var n=a[1],r=a[2],h=a[3],o=a[6],u=a[7],M=a[11];t[1]=a[4],t[2]=a[8],t[3]=a[12],t[4]=n,t[6]=a[9],t[7]=a[13],t[8]=r,t[9]=o,t[11]=a[14],t[12]=h,t[13]=u,t[14]=M}else t[0]=a[0],t[1]=a[4],t[2]=a[8],t[3]=a[12],t[4]=a[1],t[5]=a[5],t[6]=a[9],t[7]=a[13],t[8]=a[2],t[9]=a[6],t[10]=a[10],t[11]=a[14],t[12]=a[3],t[13]=a[7],t[14]=a[11],t[15]=a[15];return t},n.invert=function(t,a){var n=a[0],r=a[1],h=a[2],o=a[3],u=a[4],M=a[5],e=a[6],s=a[7],i=a[8],c=a[9],f=a[10],b=a[11],l=a[12],v=a[13],m=a[14],P=a[15],E=n*M-r*u,S=n*e-h*u,I=n*s-o*u,O=r*e-h*M,p=r*s-o*M,L=h*s-o*e,N=i*v-c*l,R=i*m-f*l,x=i*P-b*l,y=c*m-f*v,A=c*P-b*v,Y=f*P-b*m,d=E*Y-S*A+I*y+O*x-p*R+L*N;return d?(d=1/d,t[0]=(M*Y-e*A+s*y)*d,t[1]=(h*A-r*Y-o*y)*d,t[2]=(v*L-m*p+P*O)*d,t[3]=(f*p-c*L-b*O)*d,t[4]=(e*x-u*Y-s*R)*d,t[5]=(n*Y-h*x+o*R)*d,t[6]=(m*I-l*L-P*S)*d,t[7]=(i*L-f*I+b*S)*d,t[8]=(u*A-M*x+s*N)*d,t[9]=(r*x-n*A-o*N)*d,t[10]=(l*p-v*I+P*E)*d,t[11]=(c*I-i*p-b*E)*d,t[12]=(M*R-u*y-e*N)*d,t[13]=(n*y-r*R+h*N)*d,t[14]=(v*S-l*O-m*E)*d,t[15]=(i*O-c*S+f*E)*d,t):null},n.adjoint=function(t,a){var n=a[0],r=a[1],h=a[2],o=a[3],u=a[4],M=a[5],e=a[6],s=a[7],i=a[8],c=a[9],f=a[10],b=a[11],l=a[12],v=a[13],m=a[14],P=a[15];return t[0]=M*(f*P-b*m)-c*(e*P-s*m)+v*(e*b-s*f),t[1]=-(r*(f*P-b*m)-c*(h*P-o*m)+v*(h*b-o*f)),t[2]=r*(e*P-s*m)-M*(h*P-o*m)+v*(h*s-o*e),t[3]=-(r*(e*b-s*f)-M*(h*b-o*f)+c*(h*s-o*e)),t[4]=-(u*(f*P-b*m)-i*(e*P-s*m)+l*(e*b-s*f)),t[5]=n*(f*P-b*m)-i*(h*P-o*m)+l*(h*b-o*f),t[6]=-(n*(e*P-s*m)-u*(h*P-o*m)+l*(h*s-o*e)),t[7]=n*(e*b-s*f)-u*(h*b-o*f)+i*(h*s-o*e),t[8]=u*(c*P-b*v)-i*(M*P-s*v)+l*(M*b-s*c),t[9]=-(n*(c*P-b*v)-i*(r*P-o*v)+l*(r*b-o*c)),t[10]=n*(M*P-s*v)-u*(r*P-o*v)+l*(r*s-o*M),t[11]=-(n*(M*b-s*c)-u*(r*b-o*c)+i*(r*s-o*M)),t[12]=-(u*(c*m-f*v)-i*(M*m-e*v)+l*(M*f-e*c)),t[13]=n*(c*m-f*v)-i*(r*m-h*v)+l*(r*f-h*c),t[14]=-(n*(M*m-e*v)-u*(r*m-h*v)+l*(r*e-h*M)),t[15]=n*(M*f-e*c)-u*(r*f-h*c)+i*(r*e-h*M),t},n.determinant=function(t){var a=t[0],n=t[1],r=t[2],h=t[3],o=t[4],u=t[5],M=t[6],e=t[7],s=t[8],i=t[9],c=t[10],f=t[11],b=t[12],l=t[13],v=t[14],m=t[15];return(a*u-n*o)*(c*m-f*v)-(a*M-r*o)*(i*m-f*l)+(a*e-h*o)*(i*v-c*l)+(n*M-r*u)*(s*m-f*b)-(n*e-h*u)*(s*v-c*b)+(r*e-h*M)*(s*l-i*b)},n.multiply=o,n.translate=function(t,a,n){var r,h,o,u,M,e,s,i,c,f,b,l,v=n[0],m=n[1],P=n[2];return a===t?(t[12]=a[0]*v+a[4]*m+a[8]*P+a[12],t[13]=a[1]*v+a[5]*m+a[9]*P+a[13],t[14]=a[2]*v+a[6]*m+a[10]*P+a[14],t[15]=a[3]*v+a[7]*m+a[11]*P+a[15]):(r=a[0],h=a[1],o=a[2],u=a[3],M=a[4],e=a[5],s=a[6],i=a[7],c=a[8],f=a[9],b=a[10],l=a[11],t[0]=r,t[1]=h,t[2]=o,t[3]=u,t[4]=M,t[5]=e,t[6]=s,t[7]=i,t[8]=c,t[9]=f,t[10]=b,t[11]=l,t[12]=r*v+M*m+c*P+a[12],t[13]=h*v+e*m+f*P+a[13],t[14]=o*v+s*m+b*P+a[14],t[15]=u*v+i*m+l*P+a[15]),t},n.scale=function(t,a,n){var r=n[0],h=n[1],o=n[2];return t[0]=a[0]*r,t[1]=a[1]*r,t[2]=a[2]*r,t[3]=a[3]*r,t[4]=a[4]*h,t[5]=a[5]*h,t[6]=a[6]*h,t[7]=a[7]*h,t[8]=a[8]*o,t[9]=a[9]*o,t[10]=a[10]*o,t[11]=a[11]*o,t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15],t},n.rotate=function(t,a,n,h){var o,u,M,e,s,i,c,f,b,l,v,m,P,E,S,I,O,p,L,N,R,x,y,A,Y=h[0],d=h[1],g=h[2],T=Math.hypot(Y,d,g);return T<r.EPSILON?null:(Y*=T=1/T,d*=T,g*=T,o=Math.sin(n),M=1-(u=Math.cos(n)),e=a[0],s=a[1],i=a[2],c=a[3],f=a[4],b=a[5],l=a[6],v=a[7],m=a[8],P=a[9],E=a[10],S=a[11],I=Y*Y*M+u,O=d*Y*M+g*o,p=g*Y*M-d*o,L=Y*d*M-g*o,N=d*d*M+u,R=g*d*M+Y*o,x=Y*g*M+d*o,y=d*g*M-Y*o,A=g*g*M+u,t[0]=e*I+f*O+m*p,t[1]=s*I+b*O+P*p,t[2]=i*I+l*O+E*p,t[3]=c*I+v*O+S*p,t[4]=e*L+f*N+m*R,t[5]=s*L+b*N+P*R,t[6]=i*L+l*N+E*R,t[7]=c*L+v*N+S*R,t[8]=e*x+f*y+m*A,t[9]=s*x+b*y+P*A,t[10]=i*x+l*y+E*A,t[11]=c*x+v*y+S*A,a!==t&&(t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]),t)},n.rotateX=function(t,a,n){var r=Math.sin(n),h=Math.cos(n),o=a[4],u=a[5],M=a[6],e=a[7],s=a[8],i=a[9],c=a[10],f=a[11];return a!==t&&(t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]),t[4]=o*h+s*r,t[5]=u*h+i*r,t[6]=M*h+c*r,t[7]=e*h+f*r,t[8]=s*h-o*r,t[9]=i*h-u*r,t[10]=c*h-M*r,t[11]=f*h-e*r,t},n.rotateY=function(t,a,n){var r=Math.sin(n),h=Math.cos(n),o=a[0],u=a[1],M=a[2],e=a[3],s=a[8],i=a[9],c=a[10],f=a[11];return a!==t&&(t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]),t[0]=o*h-s*r,t[1]=u*h-i*r,t[2]=M*h-c*r,t[3]=e*h-f*r,t[8]=o*r+s*h,t[9]=u*r+i*h,t[10]=M*r+c*h,t[11]=e*r+f*h,t},n.rotateZ=function(t,a,n){var r=Math.sin(n),h=Math.cos(n),o=a[0],u=a[1],M=a[2],e=a[3],s=a[4],i=a[5],c=a[6],f=a[7];return a!==t&&(t[8]=a[8],t[9]=a[9],t[10]=a[10],t[11]=a[11],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]),t[0]=o*h+s*r,t[1]=u*h+i*r,t[2]=M*h+c*r,t[3]=e*h+f*r,t[4]=s*h-o*r,t[5]=i*h-u*r,t[6]=c*h-M*r,t[7]=f*h-e*r,t},n.fromTranslation=function(t,a){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=a[0],t[13]=a[1],t[14]=a[2],t[15]=1,t},n.fromScaling=function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a[1],t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=a[2],t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromRotation=function(t,a,n){var h,o,u,M=n[0],e=n[1],s=n[2],i=Math.hypot(M,e,s);return i<r.EPSILON?null:(M*=i=1/i,e*=i,s*=i,h=Math.sin(a),u=1-(o=Math.cos(a)),t[0]=M*M*u+o,t[1]=e*M*u+s*h,t[2]=s*M*u-e*h,t[3]=0,t[4]=M*e*u-s*h,t[5]=e*e*u+o,t[6]=s*e*u+M*h,t[7]=0,t[8]=M*s*u+e*h,t[9]=e*s*u-M*h,t[10]=s*s*u+o,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t)},n.fromXRotation=function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=r,t[6]=n,t[7]=0,t[8]=0,t[9]=-n,t[10]=r,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromYRotation=function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=0,t[2]=-n,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=n,t[9]=0,t[10]=r,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromZRotation=function(t,a){var n=Math.sin(a),r=Math.cos(a);return t[0]=r,t[1]=n,t[2]=0,t[3]=0,t[4]=-n,t[5]=r,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.fromRotationTranslation=u,n.fromQuat2=function(t,a){var n=new r.ARRAY_TYPE(3),h=-a[0],o=-a[1],M=-a[2],e=a[3],s=a[4],i=a[5],c=a[6],f=a[7],b=h*h+o*o+M*M+e*e;return b>0?(n[0]=2*(s*e+f*h+i*M-c*o)/b,n[1]=2*(i*e+f*o+c*h-s*M)/b,n[2]=2*(c*e+f*M+s*o-i*h)/b):(n[0]=2*(s*e+f*h+i*M-c*o),n[1]=2*(i*e+f*o+c*h-s*M),n[2]=2*(c*e+f*M+s*o-i*h)),u(t,a,n),t},n.getTranslation=function(t,a){return t[0]=a[12],t[1]=a[13],t[2]=a[14],t},n.getScaling=M,n.getRotation=function(t,a){var n=new r.ARRAY_TYPE(3);M(n,a);var h=1/n[0],o=1/n[1],u=1/n[2],e=a[0]*h,s=a[1]*o,i=a[2]*u,c=a[4]*h,f=a[5]*o,b=a[6]*u,l=a[8]*h,v=a[9]*o,m=a[10]*u,P=e+f+m,E=0;return P>0?(E=2*Math.sqrt(P+1),t[3]=.25*E,t[0]=(b-v)/E,t[1]=(l-i)/E,t[2]=(s-c)/E):e>f&&e>m?(E=2*Math.sqrt(1+e-f-m),t[3]=(b-v)/E,t[0]=.25*E,t[1]=(s+c)/E,t[2]=(l+i)/E):f>m?(E=2*Math.sqrt(1+f-e-m),t[3]=(l-i)/E,t[0]=(s+c)/E,t[1]=.25*E,t[2]=(b+v)/E):(E=2*Math.sqrt(1+m-e-f),t[3]=(s-c)/E,t[0]=(l+i)/E,t[1]=(b+v)/E,t[2]=.25*E),t},n.fromRotationTranslationScale=function(t,a,n,r){var h=a[0],o=a[1],u=a[2],M=a[3],e=h+h,s=o+o,i=u+u,c=h*e,f=h*s,b=h*i,l=o*s,v=o*i,m=u*i,P=M*e,E=M*s,S=M*i,I=r[0],O=r[1],p=r[2];return t[0]=(1-(l+m))*I,t[1]=(f+S)*I,t[2]=(b-E)*I,t[3]=0,t[4]=(f-S)*O,t[5]=(1-(c+m))*O,t[6]=(v+P)*O,t[7]=0,t[8]=(b+E)*p,t[9]=(v-P)*p,t[10]=(1-(c+l))*p,t[11]=0,t[12]=n[0],t[13]=n[1],t[14]=n[2],t[15]=1,t},n.fromRotationTranslationScaleOrigin=function(t,a,n,r,h){var o=a[0],u=a[1],M=a[2],e=a[3],s=o+o,i=u+u,c=M+M,f=o*s,b=o*i,l=o*c,v=u*i,m=u*c,P=M*c,E=e*s,S=e*i,I=e*c,O=r[0],p=r[1],L=r[2],N=h[0],R=h[1],x=h[2],y=(1-(v+P))*O,A=(b+I)*O,Y=(l-S)*O,d=(b-I)*p,g=(1-(f+P))*p,T=(m+E)*p,_=(l+S)*L,q=(m-E)*L,w=(1-(f+v))*L;return t[0]=y,t[1]=A,t[2]=Y,t[3]=0,t[4]=d,t[5]=g,t[6]=T,t[7]=0,t[8]=_,t[9]=q,t[10]=w,t[11]=0,t[12]=n[0]+N-(y*N+d*R+_*x),t[13]=n[1]+R-(A*N+g*R+q*x),t[14]=n[2]+x-(Y*N+T*R+w*x),t[15]=1,t},n.fromQuat=function(t,a){var n=a[0],r=a[1],h=a[2],o=a[3],u=n+n,M=r+r,e=h+h,s=n*u,i=r*u,c=r*M,f=h*u,b=h*M,l=h*e,v=o*u,m=o*M,P=o*e;return t[0]=1-c-l,t[1]=i+P,t[2]=f-m,t[3]=0,t[4]=i-P,t[5]=1-s-l,t[6]=b+v,t[7]=0,t[8]=f+m,t[9]=b-v,t[10]=1-s-c,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},n.frustum=function(t,a,n,r,h,o,u){var M=1/(n-a),e=1/(h-r),s=1/(o-u);return t[0]=2*o*M,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=2*o*e,t[6]=0,t[7]=0,t[8]=(n+a)*M,t[9]=(h+r)*e,t[10]=(u+o)*s,t[11]=-1,t[12]=0,t[13]=0,t[14]=u*o*2*s,t[15]=0,t},n.perspective=function(t,a,n,r,h){var o,u=1/Math.tan(a/2);return t[0]=u/n,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=u,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=h&&h!==1/0?(o=1/(r-h),t[10]=(h+r)*o,t[14]=2*h*r*o):(t[10]=-1,t[14]=-2*r),t},n.perspectiveFromFieldOfView=function(t,a,n,r){var h=Math.tan(a.upDegrees*Math.PI/180),o=Math.tan(a.downDegrees*Math.PI/180),u=Math.tan(a.leftDegrees*Math.PI/180),M=Math.tan(a.rightDegrees*Math.PI/180),e=2/(u+M),s=2/(h+o);return t[0]=e,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=s,t[6]=0,t[7]=0,t[8]=-(u-M)*e*.5,t[9]=(h-o)*s*.5,t[10]=r/(n-r),t[11]=-1,t[12]=0,t[13]=0,t[14]=r*n/(n-r),t[15]=0,t},n.ortho=function(t,a,n,r,h,o,u){var M=1/(a-n),e=1/(r-h),s=1/(o-u);return t[0]=-2*M,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*e,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*s,t[11]=0,t[12]=(a+n)*M,t[13]=(h+r)*e,t[14]=(u+o)*s,t[15]=1,t},n.lookAt=function(t,a,n,o){var u,M,e,s,i,c,f,b,l,v,m=a[0],P=a[1],E=a[2],S=o[0],I=o[1],O=o[2],p=n[0],L=n[1],N=n[2];return Math.abs(m-p)<r.EPSILON&&Math.abs(P-L)<r.EPSILON&&Math.abs(E-N)<r.EPSILON?h(t):(f=m-p,b=P-L,l=E-N,u=I*(l*=v=1/Math.hypot(f,b,l))-O*(b*=v),M=O*(f*=v)-S*l,e=S*b-I*f,(v=Math.hypot(u,M,e))?(u*=v=1/v,M*=v,e*=v):(u=0,M=0,e=0),s=b*e-l*M,i=l*u-f*e,c=f*M-b*u,(v=Math.hypot(s,i,c))?(s*=v=1/v,i*=v,c*=v):(s=0,i=0,c=0),t[0]=u,t[1]=s,t[2]=f,t[3]=0,t[4]=M,t[5]=i,t[6]=b,t[7]=0,t[8]=e,t[9]=c,t[10]=l,t[11]=0,t[12]=-(u*m+M*P+e*E),t[13]=-(s*m+i*P+c*E),t[14]=-(f*m+b*P+l*E),t[15]=1,t)},n.targetTo=function(t,a,n,r){var h=a[0],o=a[1],u=a[2],M=r[0],e=r[1],s=r[2],i=h-n[0],c=o-n[1],f=u-n[2],b=i*i+c*c+f*f;b>0&&(i*=b=1/Math.sqrt(b),c*=b,f*=b);var l=e*f-s*c,v=s*i-M*f,m=M*c-e*i;return(b=l*l+v*v+m*m)>0&&(l*=b=1/Math.sqrt(b),v*=b,m*=b),t[0]=l,t[1]=v,t[2]=m,t[3]=0,t[4]=c*m-f*v,t[5]=f*l-i*m,t[6]=i*v-c*l,t[7]=0,t[8]=i,t[9]=c,t[10]=f,t[11]=0,t[12]=h,t[13]=o,t[14]=u,t[15]=1,t},n.str=function(t){return"mat4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+", "+t[9]+", "+t[10]+", "+t[11]+", "+t[12]+", "+t[13]+", "+t[14]+", "+t[15]+")"},n.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13],t[14],t[15])},n.add=function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t[4]=a[4]+n[4],t[5]=a[5]+n[5],t[6]=a[6]+n[6],t[7]=a[7]+n[7],t[8]=a[8]+n[8],t[9]=a[9]+n[9],t[10]=a[10]+n[10],t[11]=a[11]+n[11],t[12]=a[12]+n[12],t[13]=a[13]+n[13],t[14]=a[14]+n[14],t[15]=a[15]+n[15],t},n.subtract=e,n.multiplyScalar=function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*n,t[5]=a[5]*n,t[6]=a[6]*n,t[7]=a[7]*n,t[8]=a[8]*n,t[9]=a[9]*n,t[10]=a[10]*n,t[11]=a[11]*n,t[12]=a[12]*n,t[13]=a[13]*n,t[14]=a[14]*n,t[15]=a[15]*n,t},n.multiplyScalarAndAdd=function(t,a,n,r){return t[0]=a[0]+n[0]*r,t[1]=a[1]+n[1]*r,t[2]=a[2]+n[2]*r,t[3]=a[3]+n[3]*r,t[4]=a[4]+n[4]*r,t[5]=a[5]+n[5]*r,t[6]=a[6]+n[6]*r,t[7]=a[7]+n[7]*r,t[8]=a[8]+n[8]*r,t[9]=a[9]+n[9]*r,t[10]=a[10]+n[10]*r,t[11]=a[11]+n[11]*r,t[12]=a[12]+n[12]*r,t[13]=a[13]+n[13]*r,t[14]=a[14]+n[14]*r,t[15]=a[15]+n[15]*r,t},n.exactEquals=function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]&&t[8]===a[8]&&t[9]===a[9]&&t[10]===a[10]&&t[11]===a[11]&&t[12]===a[12]&&t[13]===a[13]&&t[14]===a[14]&&t[15]===a[15]},n.equals=function(t,a){var n=t[0],h=t[1],o=t[2],u=t[3],M=t[4],e=t[5],s=t[6],i=t[7],c=t[8],f=t[9],b=t[10],l=t[11],v=t[12],m=t[13],P=t[14],E=t[15],S=a[0],I=a[1],O=a[2],p=a[3],L=a[4],N=a[5],R=a[6],x=a[7],y=a[8],A=a[9],Y=a[10],d=a[11],g=a[12],T=a[13],_=a[14],q=a[15];return Math.abs(n-S)<=r.EPSILON*Math.max(1,Math.abs(n),Math.abs(S))&&Math.abs(h-I)<=r.EPSILON*Math.max(1,Math.abs(h),Math.abs(I))&&Math.abs(o-O)<=r.EPSILON*Math.max(1,Math.abs(o),Math.abs(O))&&Math.abs(u-p)<=r.EPSILON*Math.max(1,Math.abs(u),Math.abs(p))&&Math.abs(M-L)<=r.EPSILON*Math.max(1,Math.abs(M),Math.abs(L))&&Math.abs(e-N)<=r.EPSILON*Math.max(1,Math.abs(e),Math.abs(N))&&Math.abs(s-R)<=r.EPSILON*Math.max(1,Math.abs(s),Math.abs(R))&&Math.abs(i-x)<=r.EPSILON*Math.max(1,Math.abs(i),Math.abs(x))&&Math.abs(c-y)<=r.EPSILON*Math.max(1,Math.abs(c),Math.abs(y))&&Math.abs(f-A)<=r.EPSILON*Math.max(1,Math.abs(f),Math.abs(A))&&Math.abs(b-Y)<=r.EPSILON*Math.max(1,Math.abs(b),Math.abs(Y))&&Math.abs(l-d)<=r.EPSILON*Math.max(1,Math.abs(l),Math.abs(d))&&Math.abs(v-g)<=r.EPSILON*Math.max(1,Math.abs(v),Math.abs(g))&&Math.abs(m-T)<=r.EPSILON*Math.max(1,Math.abs(m),Math.abs(T))&&Math.abs(P-_)<=r.EPSILON*Math.max(1,Math.abs(P),Math.abs(_))&&Math.abs(E-q)<=r.EPSILON*Math.max(1,Math.abs(E),Math.abs(q))},n.mul=o,n.sub=e},
"eb06fc032a": function _(t,r,a){Object.defineProperty(a,"__esModule",{value:!0});const n=t("tslib"),e=n.__importStar(t("68ca94c15c")),o=n.__importStar(t("0285c50a7e")),s=n.__importStar(t("2c5eb22089")),u=n.__importStar(t("c1aa33d719"));function c(){var t=new e.ARRAY_TYPE(4);return e.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t[3]=1,t}function i(t,r,a){a*=.5;var n=Math.sin(a);return t[0]=n*r[0],t[1]=n*r[1],t[2]=n*r[2],t[3]=Math.cos(a),t}function h(t,r,a){var n=r[0],e=r[1],o=r[2],s=r[3],u=a[0],c=a[1],i=a[2],h=a[3];return t[0]=n*h+s*u+e*i-o*c,t[1]=e*h+s*c+o*u-n*i,t[2]=o*h+s*i+n*c-e*u,t[3]=s*h-n*u-e*c-o*i,t}function M(t,r){var a=r[0],n=r[1],e=r[2],o=r[3],s=Math.sqrt(a*a+n*n+e*e),u=Math.exp(o),c=s>0?u*Math.sin(s)/s:0;return t[0]=a*c,t[1]=n*c,t[2]=e*c,t[3]=u*Math.cos(s),t}function l(t,r){var a=r[0],n=r[1],e=r[2],o=r[3],s=Math.sqrt(a*a+n*n+e*e),u=s>0?Math.atan2(s,o)/s:0;return t[0]=a*u,t[1]=n*u,t[2]=e*u,t[3]=.5*Math.log(a*a+n*n+e*e+o*o),t}function f(t,r,a,n){var o,s,u,c,i,h=r[0],M=r[1],l=r[2],f=r[3],v=a[0],m=a[1],q=a[2],d=a[3];return(s=h*v+M*m+l*q+f*d)<0&&(s=-s,v=-v,m=-m,q=-q,d=-d),1-s>e.EPSILON?(o=Math.acos(s),u=Math.sin(o),c=Math.sin((1-n)*o)/u,i=Math.sin(n*o)/u):(c=1-n,i=n),t[0]=c*h+i*v,t[1]=c*M+i*m,t[2]=c*l+i*q,t[3]=c*f+i*d,t}function v(t,r){var a,n=r[0]+r[4]+r[8];if(n>0)a=Math.sqrt(n+1),t[3]=.5*a,a=.5/a,t[0]=(r[5]-r[7])*a,t[1]=(r[6]-r[2])*a,t[2]=(r[1]-r[3])*a;else{var e=0;r[4]>r[0]&&(e=1),r[8]>r[3*e+e]&&(e=2);var o=(e+1)%3,s=(e+2)%3;a=Math.sqrt(r[3*e+e]-r[3*o+o]-r[3*s+s]+1),t[e]=.5*a,a=.5/a,t[3]=(r[3*o+s]-r[3*s+o])*a,t[o]=(r[3*o+e]+r[3*e+o])*a,t[s]=(r[3*s+e]+r[3*e+s])*a}return t}var m,q,d,p,A,g;a.create=c,a.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},a.setAxisAngle=i,a.getAxisAngle=function(t,r){var a=2*Math.acos(r[3]),n=Math.sin(a/2);return n>e.EPSILON?(t[0]=r[0]/n,t[1]=r[1]/n,t[2]=r[2]/n):(t[0]=1,t[1]=0,t[2]=0),a},a.getAngle=function(t,r){var n=a.dot(t,r);return Math.acos(2*n*n-1)},a.multiply=h,a.rotateX=function(t,r,a){a*=.5;var n=r[0],e=r[1],o=r[2],s=r[3],u=Math.sin(a),c=Math.cos(a);return t[0]=n*c+s*u,t[1]=e*c+o*u,t[2]=o*c-e*u,t[3]=s*c-n*u,t},a.rotateY=function(t,r,a){a*=.5;var n=r[0],e=r[1],o=r[2],s=r[3],u=Math.sin(a),c=Math.cos(a);return t[0]=n*c-o*u,t[1]=e*c+s*u,t[2]=o*c+n*u,t[3]=s*c-e*u,t},a.rotateZ=function(t,r,a){a*=.5;var n=r[0],e=r[1],o=r[2],s=r[3],u=Math.sin(a),c=Math.cos(a);return t[0]=n*c+e*u,t[1]=e*c-n*u,t[2]=o*c+s*u,t[3]=s*c-o*u,t},a.calculateW=function(t,r){var a=r[0],n=r[1],e=r[2];return t[0]=a,t[1]=n,t[2]=e,t[3]=Math.sqrt(Math.abs(1-a*a-n*n-e*e)),t},a.exp=M,a.ln=l,a.pow=function(t,r,n){return l(t,r),a.scale(t,t,n),M(t,t),t},a.slerp=f,a.random=function(t){var r=e.RANDOM(),a=e.RANDOM(),n=e.RANDOM(),o=Math.sqrt(1-r),s=Math.sqrt(r);return t[0]=o*Math.sin(2*Math.PI*a),t[1]=o*Math.cos(2*Math.PI*a),t[2]=s*Math.sin(2*Math.PI*n),t[3]=s*Math.cos(2*Math.PI*n),t},a.invert=function(t,r){var a=r[0],n=r[1],e=r[2],o=r[3],s=a*a+n*n+e*e+o*o,u=s?1/s:0;return t[0]=-a*u,t[1]=-n*u,t[2]=-e*u,t[3]=o*u,t},a.conjugate=function(t,r){return t[0]=-r[0],t[1]=-r[1],t[2]=-r[2],t[3]=r[3],t},a.fromMat3=v,a.fromEuler=function(t,r,a,n){var e=.5*Math.PI/180;r*=e,a*=e,n*=e;var o=Math.sin(r),s=Math.cos(r),u=Math.sin(a),c=Math.cos(a),i=Math.sin(n),h=Math.cos(n);return t[0]=o*c*h-s*u*i,t[1]=s*u*h+o*c*i,t[2]=s*c*i-o*u*h,t[3]=s*c*h+o*u*i,t},a.str=function(t){return"quat("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},a.clone=u.clone,a.fromValues=u.fromValues,a.copy=u.copy,a.set=u.set,a.add=u.add,a.mul=h,a.scale=u.scale,a.dot=u.dot,a.lerp=u.lerp,a.length=u.length,a.len=a.length,a.squaredLength=u.squaredLength,a.sqrLen=a.squaredLength,a.normalize=u.normalize,a.exactEquals=u.exactEquals,a.equals=u.equals,a.rotationTo=(m=s.create(),q=s.fromValues(1,0,0),d=s.fromValues(0,1,0),function(t,r,n){var e=s.dot(r,n);return e<-.999999?(s.cross(m,q,r),s.len(m)<1e-6&&s.cross(m,d,r),s.normalize(m,m),i(t,m,Math.PI),t):e>.999999?(t[0]=0,t[1]=0,t[2]=0,t[3]=1,t):(s.cross(m,r,n),t[0]=m[0],t[1]=m[1],t[2]=m[2],t[3]=1+e,a.normalize(t,t))}),a.sqlerp=(p=c(),A=c(),function(t,r,a,n,e,o){return f(p,r,e,o),f(A,a,n,o),f(t,p,A,2*o*(1-o)),t}),a.setAxes=(g=o.create(),function(t,r,n,e){return g[0]=n[0],g[3]=n[1],g[6]=n[2],g[1]=e[0],g[4]=e[1],g[7]=e[2],g[2]=-r[0],g[5]=-r[1],g[8]=-r[2],a.normalize(t,v(t,g))})},
"2c5eb22089": function _(t,n,r){Object.defineProperty(r,"__esModule",{value:!0});const a=t("tslib").__importStar(t("68ca94c15c"));function u(){var t=new a.ARRAY_TYPE(3);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function e(t){var n=t[0],r=t[1],a=t[2];return Math.hypot(n,r,a)}function o(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t}function i(t,n,r){return t[0]=n[0]*r[0],t[1]=n[1]*r[1],t[2]=n[2]*r[2],t}function c(t,n,r){return t[0]=n[0]/r[0],t[1]=n[1]/r[1],t[2]=n[2]/r[2],t}function h(t,n){var r=n[0]-t[0],a=n[1]-t[1],u=n[2]-t[2];return Math.hypot(r,a,u)}function M(t,n){var r=n[0]-t[0],a=n[1]-t[1],u=n[2]-t[2];return r*r+a*a+u*u}function s(t){var n=t[0],r=t[1],a=t[2];return n*n+r*r+a*a}function f(t,n){return t[0]*n[0]+t[1]*n[1]+t[2]*n[2]}var l;r.create=u,r.clone=function(t){var n=new a.ARRAY_TYPE(3);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n},r.length=e,r.fromValues=function(t,n,r){var u=new a.ARRAY_TYPE(3);return u[0]=t,u[1]=n,u[2]=r,u},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t},r.set=function(t,n,r,a){return t[0]=n,t[1]=r,t[2]=a,t},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t},r.subtract=o,r.multiply=i,r.divide=c,r.ceil=function(t,n){return t[0]=Math.ceil(n[0]),t[1]=Math.ceil(n[1]),t[2]=Math.ceil(n[2]),t},r.floor=function(t,n){return t[0]=Math.floor(n[0]),t[1]=Math.floor(n[1]),t[2]=Math.floor(n[2]),t},r.min=function(t,n,r){return t[0]=Math.min(n[0],r[0]),t[1]=Math.min(n[1],r[1]),t[2]=Math.min(n[2],r[2]),t},r.max=function(t,n,r){return t[0]=Math.max(n[0],r[0]),t[1]=Math.max(n[1],r[1]),t[2]=Math.max(n[2],r[2]),t},r.round=function(t,n){return t[0]=Math.round(n[0]),t[1]=Math.round(n[1]),t[2]=Math.round(n[2]),t},r.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t},r.scaleAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t},r.distance=h,r.squaredDistance=M,r.squaredLength=s,r.negate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t[2]=-n[2],t},r.inverse=function(t,n){return t[0]=1/n[0],t[1]=1/n[1],t[2]=1/n[2],t},r.normalize=function(t,n){var r=n[0],a=n[1],u=n[2],e=r*r+a*a+u*u;return e>0&&(e=1/Math.sqrt(e)),t[0]=n[0]*e,t[1]=n[1]*e,t[2]=n[2]*e,t},r.dot=f,r.cross=function(t,n,r){var a=n[0],u=n[1],e=n[2],o=r[0],i=r[1],c=r[2];return t[0]=u*c-e*i,t[1]=e*o-a*c,t[2]=a*i-u*o,t},r.lerp=function(t,n,r,a){var u=n[0],e=n[1],o=n[2];return t[0]=u+a*(r[0]-u),t[1]=e+a*(r[1]-e),t[2]=o+a*(r[2]-o),t},r.hermite=function(t,n,r,a,u,e){var o=e*e,i=o*(2*e-3)+1,c=o*(e-2)+e,h=o*(e-1),M=o*(3-2*e);return t[0]=n[0]*i+r[0]*c+a[0]*h+u[0]*M,t[1]=n[1]*i+r[1]*c+a[1]*h+u[1]*M,t[2]=n[2]*i+r[2]*c+a[2]*h+u[2]*M,t},r.bezier=function(t,n,r,a,u,e){var o=1-e,i=o*o,c=e*e,h=i*o,M=3*e*i,s=3*c*o,f=c*e;return t[0]=n[0]*h+r[0]*M+a[0]*s+u[0]*f,t[1]=n[1]*h+r[1]*M+a[1]*s+u[1]*f,t[2]=n[2]*h+r[2]*M+a[2]*s+u[2]*f,t},r.random=function(t,n){n=n||1;var r=2*a.RANDOM()*Math.PI,u=2*a.RANDOM()-1,e=Math.sqrt(1-u*u)*n;return t[0]=Math.cos(r)*e,t[1]=Math.sin(r)*e,t[2]=u*n,t},r.transformMat4=function(t,n,r){var a=n[0],u=n[1],e=n[2],o=r[3]*a+r[7]*u+r[11]*e+r[15];return o=o||1,t[0]=(r[0]*a+r[4]*u+r[8]*e+r[12])/o,t[1]=(r[1]*a+r[5]*u+r[9]*e+r[13])/o,t[2]=(r[2]*a+r[6]*u+r[10]*e+r[14])/o,t},r.transformMat3=function(t,n,r){var a=n[0],u=n[1],e=n[2];return t[0]=a*r[0]+u*r[3]+e*r[6],t[1]=a*r[1]+u*r[4]+e*r[7],t[2]=a*r[2]+u*r[5]+e*r[8],t},r.transformQuat=function(t,n,r){var a=r[0],u=r[1],e=r[2],o=r[3],i=n[0],c=n[1],h=n[2],M=u*h-e*c,s=e*i-a*h,f=a*c-u*i,l=u*f-e*s,v=e*M-a*f,m=a*s-u*M,d=2*o;return M*=d,s*=d,f*=d,l*=2,v*=2,m*=2,t[0]=i+M+l,t[1]=c+s+v,t[2]=h+f+m,t},r.rotateX=function(t,n,r,a){var u=[],e=[];return u[0]=n[0]-r[0],u[1]=n[1]-r[1],u[2]=n[2]-r[2],e[0]=u[0],e[1]=u[1]*Math.cos(a)-u[2]*Math.sin(a),e[2]=u[1]*Math.sin(a)+u[2]*Math.cos(a),t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t},r.rotateY=function(t,n,r,a){var u=[],e=[];return u[0]=n[0]-r[0],u[1]=n[1]-r[1],u[2]=n[2]-r[2],e[0]=u[2]*Math.sin(a)+u[0]*Math.cos(a),e[1]=u[1],e[2]=u[2]*Math.cos(a)-u[0]*Math.sin(a),t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t},r.rotateZ=function(t,n,r,a){var u=[],e=[];return u[0]=n[0]-r[0],u[1]=n[1]-r[1],u[2]=n[2]-r[2],e[0]=u[0]*Math.cos(a)-u[1]*Math.sin(a),e[1]=u[0]*Math.sin(a)+u[1]*Math.cos(a),e[2]=u[2],t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t},r.angle=function(t,n){var r=t[0],a=t[1],u=t[2],e=n[0],o=n[1],i=n[2],c=Math.sqrt(r*r+a*a+u*u)*Math.sqrt(e*e+o*o+i*i),h=c&&f(t,n)/c;return Math.acos(Math.min(Math.max(h,-1),1))},r.zero=function(t){return t[0]=0,t[1]=0,t[2]=0,t},r.str=function(t){return"vec3("+t[0]+", "+t[1]+", "+t[2]+")"},r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]},r.equals=function(t,n){var r=t[0],u=t[1],e=t[2],o=n[0],i=n[1],c=n[2];return Math.abs(r-o)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(o))&&Math.abs(u-i)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(i))&&Math.abs(e-c)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(c))},r.sub=o,r.mul=i,r.div=c,r.dist=h,r.sqrDist=M,r.len=e,r.sqrLen=s,r.forEach=(l=u(),function(t,n,r,a,u,e){var o,i;for(n||(n=3),r||(r=0),i=a?Math.min(a*n+r,t.length):t.length,o=r;o<i;o+=n)l[0]=t[o],l[1]=t[o+1],l[2]=t[o+2],u(l,l,e),t[o]=l[0],t[o+1]=l[1],t[o+2]=l[2];return t})},
"c1aa33d719": function _(t,n,r){Object.defineProperty(r,"__esModule",{value:!0});const a=t("tslib").__importStar(t("68ca94c15c"));function u(){var t=new a.ARRAY_TYPE(4);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0),t}function e(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t}function o(t,n,r){return t[0]=n[0]*r[0],t[1]=n[1]*r[1],t[2]=n[2]*r[2],t[3]=n[3]*r[3],t}function i(t,n,r){return t[0]=n[0]/r[0],t[1]=n[1]/r[1],t[2]=n[2]/r[2],t[3]=n[3]/r[3],t}function c(t,n){var r=n[0]-t[0],a=n[1]-t[1],u=n[2]-t[2],e=n[3]-t[3];return Math.hypot(r,a,u,e)}function h(t,n){var r=n[0]-t[0],a=n[1]-t[1],u=n[2]-t[2],e=n[3]-t[3];return r*r+a*a+u*u+e*e}function M(t){var n=t[0],r=t[1],a=t[2],u=t[3];return Math.hypot(n,r,a,u)}function f(t){var n=t[0],r=t[1],a=t[2],u=t[3];return n*n+r*r+a*a+u*u}var s;r.create=u,r.clone=function(t){var n=new a.ARRAY_TYPE(4);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n},r.fromValues=function(t,n,r,u){var e=new a.ARRAY_TYPE(4);return e[0]=t,e[1]=n,e[2]=r,e[3]=u,e},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t},r.set=function(t,n,r,a,u){return t[0]=n,t[1]=r,t[2]=a,t[3]=u,t},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t},r.subtract=e,r.multiply=o,r.divide=i,r.ceil=function(t,n){return t[0]=Math.ceil(n[0]),t[1]=Math.ceil(n[1]),t[2]=Math.ceil(n[2]),t[3]=Math.ceil(n[3]),t},r.floor=function(t,n){return t[0]=Math.floor(n[0]),t[1]=Math.floor(n[1]),t[2]=Math.floor(n[2]),t[3]=Math.floor(n[3]),t},r.min=function(t,n,r){return t[0]=Math.min(n[0],r[0]),t[1]=Math.min(n[1],r[1]),t[2]=Math.min(n[2],r[2]),t[3]=Math.min(n[3],r[3]),t},r.max=function(t,n,r){return t[0]=Math.max(n[0],r[0]),t[1]=Math.max(n[1],r[1]),t[2]=Math.max(n[2],r[2]),t[3]=Math.max(n[3],r[3]),t},r.round=function(t,n){return t[0]=Math.round(n[0]),t[1]=Math.round(n[1]),t[2]=Math.round(n[2]),t[3]=Math.round(n[3]),t},r.scale=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t},r.scaleAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t},r.distance=c,r.squaredDistance=h,r.length=M,r.squaredLength=f,r.negate=function(t,n){return t[0]=-n[0],t[1]=-n[1],t[2]=-n[2],t[3]=-n[3],t},r.inverse=function(t,n){return t[0]=1/n[0],t[1]=1/n[1],t[2]=1/n[2],t[3]=1/n[3],t},r.normalize=function(t,n){var r=n[0],a=n[1],u=n[2],e=n[3],o=r*r+a*a+u*u+e*e;return o>0&&(o=1/Math.sqrt(o)),t[0]=r*o,t[1]=a*o,t[2]=u*o,t[3]=e*o,t},r.dot=function(t,n){return t[0]*n[0]+t[1]*n[1]+t[2]*n[2]+t[3]*n[3]},r.cross=function(t,n,r,a){var u=r[0]*a[1]-r[1]*a[0],e=r[0]*a[2]-r[2]*a[0],o=r[0]*a[3]-r[3]*a[0],i=r[1]*a[2]-r[2]*a[1],c=r[1]*a[3]-r[3]*a[1],h=r[2]*a[3]-r[3]*a[2],M=n[0],f=n[1],s=n[2],l=n[3];return t[0]=f*h-s*c+l*i,t[1]=-M*h+s*o-l*e,t[2]=M*c-f*o+l*u,t[3]=-M*i+f*e-s*u,t},r.lerp=function(t,n,r,a){var u=n[0],e=n[1],o=n[2],i=n[3];return t[0]=u+a*(r[0]-u),t[1]=e+a*(r[1]-e),t[2]=o+a*(r[2]-o),t[3]=i+a*(r[3]-i),t},r.random=function(t,n){var r,u,e,o,i,c;n=n||1;do{i=(r=2*a.RANDOM()-1)*r+(u=2*a.RANDOM()-1)*u}while(i>=1);do{c=(e=2*a.RANDOM()-1)*e+(o=2*a.RANDOM()-1)*o}while(c>=1);var h=Math.sqrt((1-i)/c);return t[0]=n*r,t[1]=n*u,t[2]=n*e*h,t[3]=n*o*h,t},r.transformMat4=function(t,n,r){var a=n[0],u=n[1],e=n[2],o=n[3];return t[0]=r[0]*a+r[4]*u+r[8]*e+r[12]*o,t[1]=r[1]*a+r[5]*u+r[9]*e+r[13]*o,t[2]=r[2]*a+r[6]*u+r[10]*e+r[14]*o,t[3]=r[3]*a+r[7]*u+r[11]*e+r[15]*o,t},r.transformQuat=function(t,n,r){var a=n[0],u=n[1],e=n[2],o=r[0],i=r[1],c=r[2],h=r[3],M=h*a+i*e-c*u,f=h*u+c*a-o*e,s=h*e+o*u-i*a,l=-o*a-i*u-c*e;return t[0]=M*h+l*-o+f*-c-s*-i,t[1]=f*h+l*-i+s*-o-M*-c,t[2]=s*h+l*-c+M*-i-f*-o,t[3]=n[3],t},r.zero=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=0,t},r.str=function(t){return"vec4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]},r.equals=function(t,n){var r=t[0],u=t[1],e=t[2],o=t[3],i=n[0],c=n[1],h=n[2],M=n[3];return Math.abs(r-i)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(i))&&Math.abs(u-c)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(c))&&Math.abs(e-h)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(h))&&Math.abs(o-M)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(M))},r.sub=e,r.mul=o,r.div=i,r.dist=c,r.sqrDist=h,r.len=M,r.sqrLen=f,r.forEach=(s=u(),function(t,n,r,a,u,e){var o,i;for(n||(n=4),r||(r=0),i=a?Math.min(a*n+r,t.length):t.length,o=r;o<i;o+=n)s[0]=t[o],s[1]=t[o+1],s[2]=t[o+2],s[3]=t[o+3],u(s,s,e),t[o]=s[0],t[o+1]=s[1],t[o+2]=s[2],t[o+3]=s[3];return t})},
"277615c682": function _(t,a,n){Object.defineProperty(n,"__esModule",{value:!0});const r=t("tslib"),e=r.__importStar(t("68ca94c15c")),u=r.__importStar(t("eb06fc032a")),o=r.__importStar(t("a427635f32"));function i(t,a,n){var r=.5*n[0],e=.5*n[1],u=.5*n[2],o=a[0],i=a[1],s=a[2],c=a[3];return t[0]=o,t[1]=i,t[2]=s,t[3]=c,t[4]=r*c+e*s-u*i,t[5]=e*c+u*o-r*s,t[6]=u*c+r*i-e*o,t[7]=-r*o-e*i-u*s,t}function s(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t}function c(t,a,n){var r=a[0],e=a[1],u=a[2],o=a[3],i=n[4],s=n[5],c=n[6],h=n[7],f=a[4],M=a[5],l=a[6],b=a[7],v=n[0],m=n[1],R=n[2],P=n[3];return t[0]=r*P+o*v+e*R-u*m,t[1]=e*P+o*m+u*v-r*R,t[2]=u*P+o*R+r*m-e*v,t[3]=o*P-r*v-e*m-u*R,t[4]=r*h+o*i+e*c-u*s+f*P+b*v+M*R-l*m,t[5]=e*h+o*s+u*i-r*c+M*P+b*m+l*v-f*R,t[6]=u*h+o*c+r*s-e*i+l*P+b*R+f*m-M*v,t[7]=o*h-r*i-e*s-u*c+b*P-f*v-M*m-l*R,t}n.create=function(){var t=new e.ARRAY_TYPE(8);return e.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[4]=0,t[5]=0,t[6]=0,t[7]=0),t[3]=1,t},n.clone=function(t){var a=new e.ARRAY_TYPE(8);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a},n.fromValues=function(t,a,n,r,u,o,i,s){var c=new e.ARRAY_TYPE(8);return c[0]=t,c[1]=a,c[2]=n,c[3]=r,c[4]=u,c[5]=o,c[6]=i,c[7]=s,c},n.fromRotationTranslationValues=function(t,a,n,r,u,o,i){var s=new e.ARRAY_TYPE(8);s[0]=t,s[1]=a,s[2]=n,s[3]=r;var c=.5*u,h=.5*o,f=.5*i;return s[4]=c*r+h*n-f*a,s[5]=h*r+f*t-c*n,s[6]=f*r+c*a-h*t,s[7]=-c*t-h*a-f*n,s},n.fromRotationTranslation=i,n.fromTranslation=function(t,a){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=.5*a[0],t[5]=.5*a[1],t[6]=.5*a[2],t[7]=0,t},n.fromRotation=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},n.fromMat4=function(t,a){var n=u.create();o.getRotation(n,a);var r=new e.ARRAY_TYPE(3);return o.getTranslation(r,a),i(t,n,r),t},n.copy=s,n.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},n.set=function(t,a,n,r,e,u,o,i,s){return t[0]=a,t[1]=n,t[2]=r,t[3]=e,t[4]=u,t[5]=o,t[6]=i,t[7]=s,t},n.getReal=u.copy,n.getDual=function(t,a){return t[0]=a[4],t[1]=a[5],t[2]=a[6],t[3]=a[7],t},n.setReal=u.copy,n.setDual=function(t,a){return t[4]=a[0],t[5]=a[1],t[6]=a[2],t[7]=a[3],t},n.getTranslation=function(t,a){var n=a[4],r=a[5],e=a[6],u=a[7],o=-a[0],i=-a[1],s=-a[2],c=a[3];return t[0]=2*(n*c+u*o+r*s-e*i),t[1]=2*(r*c+u*i+e*o-n*s),t[2]=2*(e*c+u*s+n*i-r*o),t},n.translate=function(t,a,n){var r=a[0],e=a[1],u=a[2],o=a[3],i=.5*n[0],s=.5*n[1],c=.5*n[2],h=a[4],f=a[5],M=a[6],l=a[7];return t[0]=r,t[1]=e,t[2]=u,t[3]=o,t[4]=o*i+e*c-u*s+h,t[5]=o*s+u*i-r*c+f,t[6]=o*c+r*s-e*i+M,t[7]=-r*i-e*s-u*c+l,t},n.rotateX=function(t,a,n){var r=-a[0],e=-a[1],o=-a[2],i=a[3],s=a[4],c=a[5],h=a[6],f=a[7],M=s*i+f*r+c*o-h*e,l=c*i+f*e+h*r-s*o,b=h*i+f*o+s*e-c*r,v=f*i-s*r-c*e-h*o;return u.rotateX(t,a,n),r=t[0],e=t[1],o=t[2],i=t[3],t[4]=M*i+v*r+l*o-b*e,t[5]=l*i+v*e+b*r-M*o,t[6]=b*i+v*o+M*e-l*r,t[7]=v*i-M*r-l*e-b*o,t},n.rotateY=function(t,a,n){var r=-a[0],e=-a[1],o=-a[2],i=a[3],s=a[4],c=a[5],h=a[6],f=a[7],M=s*i+f*r+c*o-h*e,l=c*i+f*e+h*r-s*o,b=h*i+f*o+s*e-c*r,v=f*i-s*r-c*e-h*o;return u.rotateY(t,a,n),r=t[0],e=t[1],o=t[2],i=t[3],t[4]=M*i+v*r+l*o-b*e,t[5]=l*i+v*e+b*r-M*o,t[6]=b*i+v*o+M*e-l*r,t[7]=v*i-M*r-l*e-b*o,t},n.rotateZ=function(t,a,n){var r=-a[0],e=-a[1],o=-a[2],i=a[3],s=a[4],c=a[5],h=a[6],f=a[7],M=s*i+f*r+c*o-h*e,l=c*i+f*e+h*r-s*o,b=h*i+f*o+s*e-c*r,v=f*i-s*r-c*e-h*o;return u.rotateZ(t,a,n),r=t[0],e=t[1],o=t[2],i=t[3],t[4]=M*i+v*r+l*o-b*e,t[5]=l*i+v*e+b*r-M*o,t[6]=b*i+v*o+M*e-l*r,t[7]=v*i-M*r-l*e-b*o,t},n.rotateByQuatAppend=function(t,a,n){var r=n[0],e=n[1],u=n[2],o=n[3],i=a[0],s=a[1],c=a[2],h=a[3];return t[0]=i*o+h*r+s*u-c*e,t[1]=s*o+h*e+c*r-i*u,t[2]=c*o+h*u+i*e-s*r,t[3]=h*o-i*r-s*e-c*u,i=a[4],s=a[5],c=a[6],h=a[7],t[4]=i*o+h*r+s*u-c*e,t[5]=s*o+h*e+c*r-i*u,t[6]=c*o+h*u+i*e-s*r,t[7]=h*o-i*r-s*e-c*u,t},n.rotateByQuatPrepend=function(t,a,n){var r=a[0],e=a[1],u=a[2],o=a[3],i=n[0],s=n[1],c=n[2],h=n[3];return t[0]=r*h+o*i+e*c-u*s,t[1]=e*h+o*s+u*i-r*c,t[2]=u*h+o*c+r*s-e*i,t[3]=o*h-r*i-e*s-u*c,i=n[4],s=n[5],c=n[6],h=n[7],t[4]=r*h+o*i+e*c-u*s,t[5]=e*h+o*s+u*i-r*c,t[6]=u*h+o*c+r*s-e*i,t[7]=o*h-r*i-e*s-u*c,t},n.rotateAroundAxis=function(t,a,n,r){if(Math.abs(r)<e.EPSILON)return s(t,a);var u=Math.hypot(n[0],n[1],n[2]);r*=.5;var o=Math.sin(r),i=o*n[0]/u,c=o*n[1]/u,h=o*n[2]/u,f=Math.cos(r),M=a[0],l=a[1],b=a[2],v=a[3];t[0]=M*f+v*i+l*h-b*c,t[1]=l*f+v*c+b*i-M*h,t[2]=b*f+v*h+M*c-l*i,t[3]=v*f-M*i-l*c-b*h;var m=a[4],R=a[5],P=a[6],d=a[7];return t[4]=m*f+d*i+R*h-P*c,t[5]=R*f+d*c+P*i-m*h,t[6]=P*f+d*h+m*c-R*i,t[7]=d*f-m*i-R*c-P*h,t},n.add=function(t,a,n){return t[0]=a[0]+n[0],t[1]=a[1]+n[1],t[2]=a[2]+n[2],t[3]=a[3]+n[3],t[4]=a[4]+n[4],t[5]=a[5]+n[5],t[6]=a[6]+n[6],t[7]=a[7]+n[7],t},n.multiply=c,n.mul=c,n.scale=function(t,a,n){return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*n,t[5]=a[5]*n,t[6]=a[6]*n,t[7]=a[7]*n,t},n.dot=u.dot,n.lerp=function(t,a,r,e){var u=1-e;return n.dot(a,r)<0&&(e=-e),t[0]=a[0]*u+r[0]*e,t[1]=a[1]*u+r[1]*e,t[2]=a[2]*u+r[2]*e,t[3]=a[3]*u+r[3]*e,t[4]=a[4]*u+r[4]*e,t[5]=a[5]*u+r[5]*e,t[6]=a[6]*u+r[6]*e,t[7]=a[7]*u+r[7]*e,t},n.invert=function(t,a){var r=n.squaredLength(a);return t[0]=-a[0]/r,t[1]=-a[1]/r,t[2]=-a[2]/r,t[3]=a[3]/r,t[4]=-a[4]/r,t[5]=-a[5]/r,t[6]=-a[6]/r,t[7]=a[7]/r,t},n.conjugate=function(t,a){return t[0]=-a[0],t[1]=-a[1],t[2]=-a[2],t[3]=a[3],t[4]=-a[4],t[5]=-a[5],t[6]=-a[6],t[7]=a[7],t},n.length=u.length,n.len=n.length,n.squaredLength=u.squaredLength,n.sqrLen=n.squaredLength,n.normalize=function(t,a){var r=n.squaredLength(a);if(r>0){r=Math.sqrt(r);var e=a[0]/r,u=a[1]/r,o=a[2]/r,i=a[3]/r,s=a[4],c=a[5],h=a[6],f=a[7],M=e*s+u*c+o*h+i*f;t[0]=e,t[1]=u,t[2]=o,t[3]=i,t[4]=(s-e*M)/r,t[5]=(c-u*M)/r,t[6]=(h-o*M)/r,t[7]=(f-i*M)/r}return t},n.str=function(t){return"quat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+")"},n.exactEquals=function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]},n.equals=function(t,a){var n=t[0],r=t[1],u=t[2],o=t[3],i=t[4],s=t[5],c=t[6],h=t[7],f=a[0],M=a[1],l=a[2],b=a[3],v=a[4],m=a[5],R=a[6],P=a[7];return Math.abs(n-f)<=e.EPSILON*Math.max(1,Math.abs(n),Math.abs(f))&&Math.abs(r-M)<=e.EPSILON*Math.max(1,Math.abs(r),Math.abs(M))&&Math.abs(u-l)<=e.EPSILON*Math.max(1,Math.abs(u),Math.abs(l))&&Math.abs(o-b)<=e.EPSILON*Math.max(1,Math.abs(o),Math.abs(b))&&Math.abs(i-v)<=e.EPSILON*Math.max(1,Math.abs(i),Math.abs(v))&&Math.abs(s-m)<=e.EPSILON*Math.max(1,Math.abs(s),Math.abs(m))&&Math.abs(c-R)<=e.EPSILON*Math.max(1,Math.abs(c),Math.abs(R))&&Math.abs(h-P)<=e.EPSILON*Math.max(1,Math.abs(h),Math.abs(P))}},
"c56d9ff837": function _(n,t,r){Object.defineProperty(r,"__esModule",{value:!0});const a=n("tslib").__importStar(n("68ca94c15c"));function u(){var n=new a.ARRAY_TYPE(2);return a.ARRAY_TYPE!=Float32Array&&(n[0]=0,n[1]=0),n}function e(n,t,r){return n[0]=t[0]-r[0],n[1]=t[1]-r[1],n}function o(n,t,r){return n[0]=t[0]*r[0],n[1]=t[1]*r[1],n}function c(n,t,r){return n[0]=t[0]/r[0],n[1]=t[1]/r[1],n}function i(n,t){var r=t[0]-n[0],a=t[1]-n[1];return Math.hypot(r,a)}function f(n,t){var r=t[0]-n[0],a=t[1]-n[1];return r*r+a*a}function s(n){var t=n[0],r=n[1];return Math.hypot(t,r)}function h(n){var t=n[0],r=n[1];return t*t+r*r}var M;r.create=u,r.clone=function(n){var t=new a.ARRAY_TYPE(2);return t[0]=n[0],t[1]=n[1],t},r.fromValues=function(n,t){var r=new a.ARRAY_TYPE(2);return r[0]=n,r[1]=t,r},r.copy=function(n,t){return n[0]=t[0],n[1]=t[1],n},r.set=function(n,t,r){return n[0]=t,n[1]=r,n},r.add=function(n,t,r){return n[0]=t[0]+r[0],n[1]=t[1]+r[1],n},r.subtract=e,r.multiply=o,r.divide=c,r.ceil=function(n,t){return n[0]=Math.ceil(t[0]),n[1]=Math.ceil(t[1]),n},r.floor=function(n,t){return n[0]=Math.floor(t[0]),n[1]=Math.floor(t[1]),n},r.min=function(n,t,r){return n[0]=Math.min(t[0],r[0]),n[1]=Math.min(t[1],r[1]),n},r.max=function(n,t,r){return n[0]=Math.max(t[0],r[0]),n[1]=Math.max(t[1],r[1]),n},r.round=function(n,t){return n[0]=Math.round(t[0]),n[1]=Math.round(t[1]),n},r.scale=function(n,t,r){return n[0]=t[0]*r,n[1]=t[1]*r,n},r.scaleAndAdd=function(n,t,r,a){return n[0]=t[0]+r[0]*a,n[1]=t[1]+r[1]*a,n},r.distance=i,r.squaredDistance=f,r.length=s,r.squaredLength=h,r.negate=function(n,t){return n[0]=-t[0],n[1]=-t[1],n},r.inverse=function(n,t){return n[0]=1/t[0],n[1]=1/t[1],n},r.normalize=function(n,t){var r=t[0],a=t[1],u=r*r+a*a;return u>0&&(u=1/Math.sqrt(u)),n[0]=t[0]*u,n[1]=t[1]*u,n},r.dot=function(n,t){return n[0]*t[0]+n[1]*t[1]},r.cross=function(n,t,r){var a=t[0]*r[1]-t[1]*r[0];return n[0]=n[1]=0,n[2]=a,n},r.lerp=function(n,t,r,a){var u=t[0],e=t[1];return n[0]=u+a*(r[0]-u),n[1]=e+a*(r[1]-e),n},r.random=function(n,t){t=t||1;var r=2*a.RANDOM()*Math.PI;return n[0]=Math.cos(r)*t,n[1]=Math.sin(r)*t,n},r.transformMat2=function(n,t,r){var a=t[0],u=t[1];return n[0]=r[0]*a+r[2]*u,n[1]=r[1]*a+r[3]*u,n},r.transformMat2d=function(n,t,r){var a=t[0],u=t[1];return n[0]=r[0]*a+r[2]*u+r[4],n[1]=r[1]*a+r[3]*u+r[5],n},r.transformMat3=function(n,t,r){var a=t[0],u=t[1];return n[0]=r[0]*a+r[3]*u+r[6],n[1]=r[1]*a+r[4]*u+r[7],n},r.transformMat4=function(n,t,r){var a=t[0],u=t[1];return n[0]=r[0]*a+r[4]*u+r[12],n[1]=r[1]*a+r[5]*u+r[13],n},r.rotate=function(n,t,r,a){var u=t[0]-r[0],e=t[1]-r[1],o=Math.sin(a),c=Math.cos(a);return n[0]=u*c-e*o+r[0],n[1]=u*o+e*c+r[1],n},r.angle=function(n,t){var r=n[0],a=n[1],u=t[0],e=t[1],o=Math.sqrt(r*r+a*a)*Math.sqrt(u*u+e*e),c=o&&(r*u+a*e)/o;return Math.acos(Math.min(Math.max(c,-1),1))},r.zero=function(n){return n[0]=0,n[1]=0,n},r.str=function(n){return"vec2("+n[0]+", "+n[1]+")"},r.exactEquals=function(n,t){return n[0]===t[0]&&n[1]===t[1]},r.equals=function(n,t){var r=n[0],u=n[1],e=t[0],o=t[1];return Math.abs(r-e)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(e))&&Math.abs(u-o)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(o))},r.len=s,r.sub=e,r.mul=o,r.div=c,r.dist=i,r.sqrDist=f,r.sqrLen=h,r.forEach=(M=u(),function(n,t,r,a,u,e){var o,c;for(t||(t=2),r||(r=0),c=a?Math.min(a*t+r,n.length):n.length,o=r;o<c;o+=t)M[0]=n[o],M[1]=n[o+1],u(M,M,e),n[o]=M[0],n[o+1]=M[1];return n})},
}, "22ae8fda70", {"index":"22ae8fda70","ace":"3343056bd8","layout":"ba20932521","audio":"66d52165db","comm_manager":"71a9759436","deckgl":"f6b9b1d914","tooltips":"064eac2866","html":"ae707e931d","json":"9ba5b8422a","file_download":"a94e371ba4","katex":"7b859fb3cf","mathjax":"0c21036737","player":"000f20fdd3","plotly":"2363c12dd6","util":"990b5dd5c7","progress":"76307e5afa","state":"38b2bc9574","vega":"90d1f929bd","video":"b0c3e9e9c2","videostream":"3c7145a2fa","vtk/index":"ecfbb965eb","vtk/vtk":"5b5e56e89a","vtk/vtk_layout":"c704c63c0a","vtk/vtk_utils":"ba07c3d566","vtk/vtkvolume":"729dd26c71","vtk/vtkaxes":"e23461e5d7"}, {});
})

